--[[
##########################################################
Inked! by: keivamp
##########################################################
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
--local L = LibStub("AceLocale-3.0")

function Inked:GetOptions()
    local db = self.db.char
    local options = {
        name = "Inked",
        handler = Inked,
        type = "group",
       -- childGroups = "tab",
        args = {
			 General = {
                order = 1,
                name = "General",
                type = "group",
                args = {
                   
                    AutoVender = {
                        order = 2,
                        name = "Auto Vender",
                      --  desc = "Auto Vender.",
                        descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.AutoVender end,
                        set = function(info, value) db.AutoVender = value end
                    },
					AutoRepair = {
                        order = 3,
                        name = "Auto Repair",
                       -- desc = "Auto Repair.",
                        descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.AutoRepair end,
                        set = function(info, value) db.AutoRepair = value end
                    },
					CAS = {
                        order = 4,
                        name = "Combat Alert System",
                       -- desc = "Auto Repair.",
                        descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.CAS end,
                        set = function(info, value) db.CAS = value end
                    },
					Sil = {
                        order = 5,
                        name = "Simple Item Level",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.Sil end,
                        set = function(info, value) db.Sil = value end
                    },
					SAL = {
                        order = 6,
                        name = "Speedy Auto Loot",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.SAL end,
                        set = function(info, value) db.SAL = value end
                    },
					iQL = {
                        order = 7,
                        name = "Inked Quest Log",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.iQL end,
                        set = function(info, value) db.iQL = value end
                    },
					AK = {
                        order = 8,
                        name = "Already Known",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.AK end,
                        set = function(info, value) db.AK = value end
                    },
					AfK = {
                        order = 9,
                        name = "AFK",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.AfK end,
                        set = function(info, value) db.AfK = value end
                    },

             
                }
            },
			Minimap = {
                order = 10,
                name = "Minimap",
                type = "group",
                args = {
				
										TidyM = {
                        order = 11,
                        name = "Tidy Map",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.TidyM end,
                        set = function(info, value) db.TidyM = value end
                    },
					iMM = {
                        order = 12,
                        name = "Inked Mini Map",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.iMM end,
                        set = function(info, value) db.iMM = value end
                    },
					MapLive = {
                        order = 13,
                        name = "Map Live Edit",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.MapLive end,
                        set = function(info, value) db.MapLive = value end
                    },
					iMMSize = {
                        order = 14,
                        name = "Mini Map Size",
                       -- descStyle = "inline",
                        type = "range",
                        width = "full",
						min = 100,
						max = 450,
						softMin = 100,
						softMax  = 450,
						---step  = 5,
						bigStep = 25,
						isPercent = false,
                        get = function() return db.iMMSize end,
                        set = function(info, value) db.iMMSize = value end
                    },
					iMMX = {
                        order = 15,
                        name = "MiniMap X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.iMMX end,
                        set = function(info, value) db.iMMX = value end
                    },
					iMMY = {
                        order = 16,
                        name = "MiniMap Y Pos",
                        type = "range",
                        width = "full",
						min = -1500,
						max = 2500,
						softMin = -1500,
						softMax  = 2500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.iMMY end,
                        set = function(info, value) db.iMMY = value end
                    },
				}
			},
			Gold = {
                order = 20,
                name = "Gold",
                type = "group",
                args = {
				Gold = {
                        order = 21,
                        name = "Gold Text",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.Gold end,
                        set = function(info, value) db.Gold = value end
                    },
					GoldLive = {
                        order = 22,
                        name = "Gold Live Edit",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.GoldLive end,
                        set = function(info, value) db.GoldLive = value end
                    },
					GoldTextSize = {
                        order = 23,
                        name = "Gold Text Size",
                       -- descStyle = "inline",
                        type = "range",
                        width = "full",
						min = 8,
						max = 50,
						softMin = 8,
						softMax  = 50,
						---step  = 5,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.GoldTextSize end,
                        set = function(info, value) db.GoldTextSize = value end
                    },
					GoldX = {
                        order = 24,
                        name = "Gold X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.GoldX end,
                        set = function(info, value) db.GoldX = value end
                    },
					GoldY = {
                        order = 25,
                        name = "Gold Y Pos",
                        type = "range",
                        width = "full",
						min = -1500,
						max = 2500,
						softMin = -1500,
						softMax  = 2500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.GoldY end,
                        set = function(info, value) db.GoldY = value end
                    },
				}
				
			},
			Durability = {
                order = 30,
                name = "Durability",
                type = "group",
                args = {
				Durabilty = {
                        order = 31,
                        name = "Durabilty Text",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.Durabilty end,
                        set = function(info, value) db.Durabilty = value end
                    },
					DurabiltyLive = {
                        order = 32,
                        name = "Durabilty Live Edit",
                       -- descStyle = "inline",
                        type = "toggle",
                        width = "full",
                        get = function() return db.DurabiltyLive end,
                        set = function(info, value) db.DurabiltyLive = value end
                    },
					DurabiltyTextSize = {
                        order = 33,
                        name = "Durabilty Text Size",
                       -- descStyle = "inline",
                        type = "range",
                        width = "full",
						min = 8,
						max = 50,
						softMin = 8,
						softMax  = 50,
						---step  = 5,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.DurabiltyTextSize end,
                        set = function(info, value) db.DurabiltyTextSize = value end
                    },
					DurabiltyX = {
                        order = 34,
                        name = "Durabilty X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.DurabiltyX end,
                        set = function(info, value) db.DurabiltyX = value end
                    },
					DurabiltyY = {
                        order = 34,
                        name = "Durabilty Y Pos",
                        type = "range",
                        width = "full",
						min = -1500,
						max = 2500,
						softMin = -1500,
						softMax  = 2500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.DurabiltyY end,
                        set = function(info, value) db.DurabiltyY = value end
                    },
				}
				
			},
			UnitFrames = {
                order = 40,
                name = "Unit Frames",
                type = "group",
                args = {
                   Info1 = {
                        order = 41,
                        name = "Type /MuF to unlock and lock the Unit frames",
						desc  = "Type /MuF to unlock and lock the Unit frames",
                       type = "description",
                       width = "full",
						fontSize = "large",

                    },
					 Info2 = {
                        order = 42,
                        name = "-----------------------------------------------------",					
                       type = "description",
                       width = "full",
						fontSize = "large",
                        
                    },
					
                    UF1 = {
                        order = 43,
                        name = "Unit Frame 1",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UF1 end,
                        set = function(info, value) db.UF1 = value db.UF2 = false db.UF3 = false db.UF4 = false end
                    },
					img1 = {
                        order = 44,
                        name = "",
                        type = "description",
                        width = "full",
						image  = "Interface\\Addons\\Inked\\Textures\\Unit Frames\\InkedCFG_UnitFrames1",
						imageWidth  = 256,
						imageHeight = 128,
                       
                    },
					UF2 = {
                        order = 45,
                        name = "Unit Frame 2",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UF2 end,
                        set = function(info, value) db.UF2 = value db.UF1 = false db.UF3 = false db.UF4 = false  end
						
						
                    },
					img2 = {
                        order = 46,
                        name = "",
                        type = "description",
                        width = "full",
						image  = "Interface\\Addons\\Inked\\Textures\\Unit Frames\\InkedCFG_UnitFrames2",
						imageWidth  = 256,
						imageHeight = 128,
                       
                    },
					UF3 = {
                        order = 47,
                        name = "Unit Frame 3",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UF3 end,
                        set = function(info, value) db.UF3 = value db.UF1 = false db.UF2 = false db.UF4 = false end
                    },
					img3 = {
                        order = 48,
                        name = "",
                        type = "description",
                        width = "full",
						image  = "Interface\\Addons\\Inked\\Textures\\Unit Frames\\InkedCFG_UnitFrames3",
						imageWidth  = 256,
						imageHeight = 128,
                       
                    },
					UF4 = {
                        order = 49,
                        name = "Unit Frame 4",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UF4 end,
                        set = function(info, value) db.UF4 = value db.UF1 = false db.UF2 = false db.UF3 = false end
                    },
					img4 = {
                        order = 50,
                        name = "",
                        type = "description",
                        width = "full",
						image  = "Interface\\Addons\\Inked\\Textures\\Unit Frames\\InkedCFG_UnitFrames4",
						imageWidth  = 256,
						imageHeight = 128,
                       
                    },

             
                }
            },
			UnitFramesAdjustments = {
                order = 60,
                name = "Unit Settings",
                type = "group",
                args = {
				SwingTimer = {
                        order = 61,
                        name = "Swing Timer",
                        type = "toggle",
                        width = "full",
                        get = function() return db.SwingTimer end,
                        set = function(info, value) db.SwingTimer = value end
                    },
				PlayerAuraIcons = {
                        order = 62,
                        name = "Buff Icons on Unit Frames",
                        type = "toggle",
                        width = "full",
                        get = function() return db.PlayerAuraIcons end,
                        set = function(info, value) db.PlayerAuraIcons = value end
                    },
				InkedFloatingCombatText = {
                        order = 63,
                        name = "Inked Floating Combat Text",
                        type = "toggle",
                        width = "full",
                        get = function() return db.InkedFloatingCombatText end,
                        set = function(info, value) db.InkedFloatingCombatText = value end
                    },
				DruidManaBar = {
                        order = 64,
                        name = "Druid Mana Bar for SahpeS hifted Forms",
                        type = "toggle",
                        width = "full",
                        get = function() return db.DruidManaBar end,
                        set = function(info, value) db.DruidManaBar = value end
                    },

				
				}
			},
			XPBar = {
                order = 70,
                name = "XP Bar Settings",
                type = "group",
                args = {
				UseXPBar = {
                        order = 71,
                        name = "XP Bar",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UseXPBar end,
                        set = function(info, value) db.UseXPBar = value end
                    },
				XPX = {
                        order = 72,
                        name = "XP X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.XPX end,
                        set = function(info, value) db.XPX = value end
                    },
				XPY = {
                        order = 73,
                        name = "XP Y Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.XPY end,
                        set = function(info, value) db.XPY = value end
                    },
				XPH = {
                        order = 74,
                        name = "XP Height",
                        type = "range",
                        width = "full",
						min = 8,
						max = 200,
						softMin = 8,
						softMax  = 200,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.XPH end,
                        set = function(info, value) db.XPH = value end
                    },
				XPW = {
                        order = 75,
                        name = "XP Width",
                        type = "range",
                        width = "full",
						min = 50,
						max = 1500,
						softMin = 50,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.XPW end,
                        set = function(info, value) db.XPW = value end
                    },
				UsePetXPBar = {
                        order = 76,
                        name = "XP Pet Bar",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UsePetXPBar end,
                        set = function(info, value) db.UsePetXPBar = value end
                    },
				PetXPX = {
                        order = 77,
                        name = "Pet XP X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.PetXPX end,
                        set = function(info, value) db.PetXPX = value end
                    },
				PetXPY = {
                        order = 78,
                        name = "Pet XP Y Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.PetXPY end,
                        set = function(info, value) db.PetXPY = value end
                    },
				PetXPH = {
                        order = 79,
                        name = "Pet XP Height",
                        type = "range",
                        width = "full",
						min = 8,
						max = 200,
						softMin = 8,
						softMax  = 200,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.PetXPH end,
                        set = function(info, value) db.PetXPH = value end
                    },
				PetXPW = {
                        order = 80,
                        name = "Pet XP Width",
                        type = "range",
                        width = "full",
						min = 50,
						max = 1500,
						softMin = 50,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.PetXPW end,
                        set = function(info, value) db.PetXPW = value end
                    },

				}
			},
			RepBar = {
                order = 90,
                name = "Rep Bar Settings",
                type = "group",
                args = {
				UseAutoRep = {
                        order = 91,
                        name = "Auto Rep Tracking",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UseAutoRep end,
                        set = function(info, value) db.UseAutoRep = value end
                    },
				UseRepBar = {
                        order = 92,
                        name = "Rep Bar",
                        type = "toggle",
                        width = "full",
                        get = function() return db.UseRepBar end,
                        set = function(info, value) db.UseRepBar = value end
                    },
				RepX = {
                        order = 93,
                        name = "Rep X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.RepX end,
                        set = function(info, value) db.RepX = value end
                    },
				RepY = {
                        order = 94,
                        name = "Rep Y Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.RepY end,
                        set = function(info, value) db.RepY = value end
                    },
				RepH = {
                        order = 95,
                        name = "Rep Height",
                        type = "range",
                        width = "full",
						min = 8,
						max = 200,
						softMin = 8,
						softMax  = 200,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.RepH end,
                        set = function(info, value) db.RepH = value end
                    },
				RepW = {
                        order = 96,
                        name = "Rep Width",
                        type = "range",
                        width = "full",
						min = 50,
						max = 1500,
						softMin = 50,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.RepW end,
                        set = function(info, value) db.RepW = value end
                    },
				
				}
			},
			MicroMenuAndBags = {
                order = 100,
                name = "Micro Menu & Bags",
                type = "group",
                args = {
				ShowBags = {
                        order = 101,
                        name = "Show Bags",
                        type = "toggle",
                        width = "full",
                        get = function() return db.ShowBags end,
                        set = function(info, value) db.ShowBags = value end
                    },

				BagsScale = {
                        order = 103,
                        name = "Bags Scale",
                        type = "range",
                        width = "full",
						min = 0.25,
						max = 3.5,
						softMin = 0.25,
						softMax  = 3.5,
						bigStep = 0.05,
						isPercent = false,
                        get = function() return db.BagsScale end,
                        set = function(info, value) db.BagsScale = value end
                    },
				BagsX = {
                        order = 104,
                        name = "Bags X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.BagsX end,
                        set = function(info, value) db.BagsX = value end
                    },
				BagsY = {
                        order = 105,
                        name = "Bags Y Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.BagsY end,
                        set = function(info, value) db.BagsY = value end
                    },
				ShowMicro = {
                        order = 106,
                        name = "Show MicroMenu",
                        type = "toggle",
                        width = "full",
                        get = function() return db.ShowMicro end,
                        set = function(info, value) db.ShowMicro = value  end
                    },
				MicroScale = {
                        order = 107,
                        name = "MicroMenu Scale",
                        type = "range",
                        width = "full",
						min = 0.25,
						max = 3.5,
						softMin = 0.25,
						softMax  = 3.5,
						bigStep = 0.05,
						isPercent = false,
                        get = function() return db.MicroScale end,
                        set = function(info, value) db.MicroScale = value end
                    },
				MicroX = {
                        order = 108,
                        name = "MicroMenu X Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.MicroX end,
                        set = function(info, value) db.MicroX = value end
                    },
				MicroY = {
                        order = 109,
                        name = "MicroMenu Y Pos",
                        type = "range",
                        width = "full",
						min = -2500,
						max = 1500,
						softMin = -2500,
						softMax  = 1500,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.MicroY end,
                        set = function(info, value) db.MicroY = value end
                    },
				
				
				}
			},
			ActionBars = {
                order = 110,
                name = "Action Bars",
                type = "group",
                args = {
				RangeIndicator = {
                        order = 111,
                        name = "Range Indicator",
                        type = "toggle",
                        width = "full",
                        get = function() return db.RangeIndicator end,
                        set = function(info, value) db.RangeIndicator = value end
                    },
				--UseActionBars = {
                  --      order = 112,
                 ---       name = "Use Inked's Action Bar Setup",
                   --     type = "toggle",
                   --     width = "full",
                  --      get = function() return db.UseActionBars end,
                  --      set = function(info, value) db.UseActionBars = value end
                   -- },

				}
			},
       
        }
    }
    return options
end