--[[
##########################################################
Inked!: keivamp
##########################################################
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")

---Objective Frame ---
    local addon, ns = ...
	local G, F, C, L = unpack(select(2,...))
	local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
	
	local MyQuestFrame = CreateFrame("Frame",nil,Minimap)
		MyQuestFrame:SetFrameLevel(10)
		MyQuestFrame:SetWidth(256) -- Set these to whatever height/width is needed 
		MyQuestFrame:SetHeight(128) -- for your Texture
		MyQuestFrame:SetScale(0.65)
		MyQuestFrame:SetPoint("CENTER",-375,-375)
		MyQuestFrame:SetAlpha(1)
		MyQuestFrame:SetMovable(true)
		MyQuestFrame:EnableMouse(true)
		MyQuestFrame:RegisterForDrag("LeftButton")
		MyQuestFrame:SetScript("OnDragStart", MyQuestFrame.StartMoving)
		MyQuestFrame:SetScript("OnDragStop", MyQuestFrame.StopMovingOrSizing)
		MyQuestFrame:SetClampedToScreen(true)
		MyQuestFrame:SetClampRectInsets(0, 0, 0,0)
		MyQuestFrame:SetUserPlaced(true)

		
		local CheckDB = CreateFrame("Frame")
		CheckDB:RegisterEvent("PLAYER_ENTERING_WORLD")
		CheckDB:SetScript("OnEvent", function()
		
		if Inked.db.char.iQL == false then 
		QuestWatchFrame:ClearAllPoints()
		QuestWatchFrame:SetPoint("TOPLEFT", Minimap,"TOPRIGHT", -275,-275)
		QuestWatchFrame:SetScale(1.2)
		
		else
			local MyQuestFrametex = MyQuestFrame:CreateTexture(nil, "BACKGROUND")
			MyQuestFrametex:SetAllPoints()
				if UnitClass("player") == "Shaman" then
					MyRed = color.r * 0
					MyGreen = color.g * 0.44
					MyBlue = color.b * 0.87	
				end
			MyQuestFrametex:SetVertexColor(MyRed, MyGreen, MyBlue, 1);
			MyQuestFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\QuestBar")
			QuestWatchFrame:ClearAllPoints()
			QuestWatchFrame:SetPoint("TOPLEFT", MyQuestFrame,"TOPRIGHT", -128,-55)
			QuestWatchFrame:SetScale(1.3)
		end
		end)
		
	
	


	local function UltraTrack(self, event, ...)
		local questIndex, questId = ...
		if not IsQuestComplete(questId) then
			AddQuestWatch(questIndex)
		end
	end

	local UltraQuestEvent = CreateFrame("FRAME")
	UltraQuestEvent:RegisterEvent("QUEST_ACCEPTED")
	UltraQuestEvent:SetScript("OnEvent", UltraTrack)

    local f = {}

    local OnMouseUp = function(self)
    	if  IsShiftKeyDown() then
    		local qID = GetQuestIDFromLogIndex(self.qID)
    		for i, v in ipairs(QUEST_WATCH_LIST) do
    			if v.id == qID then
    				tremove(QUEST_WATCH_LIST, i)
    			end
    		end
    		RemoveQuestWatch(self.qID)
    		QuestWatch_Update()
    	else
    		ShowUIPanel(QuestLogFrame)
    		QuestLog_SetSelection(self.qID)
    	end
    	QuestLog_Update()
    end
    local SetHighlightColor = function(self)
    	self.header:SetTextColor(1, .8, 0)
    	for _, t in ipairs(self.objective) do
    		t:SetTextColor(1, 1, 1)
			
    	end
    end
    local SetNormalColor = function(self)
    	self.header:SetTextColor(.75, .61, 0)
    	for _, t in ipairs(self.objective) do
    		t:SetTextColor(.8, .8, .8)
			
    	end
    end
    local OnEnter = function(self)
    	if  not self.completed then
    		SetHighlightColor(self)
    	end
    end
    local OnLeave = function(self)
    	SetNormalColor(self)
    end
    local CreateClickFrame = function(watchID, qID, header, objective, completed)
    	if  not f[watchID] then
    		f[watchID] = CreateFrame'Frame'
    		f[watchID]:SetScript('OnMouseUp', OnMouseUp)
    		f[watchID]:SetScript('OnEnter', OnEnter)
    		f[watchID]:SetScript('OnLeave', OnLeave)
    	end
    	local frame = f[watchID]
    	frame:SetAllPoints(header)
    	frame.watchID      = watchID
    	frame.qID          = qID
    	frame.header       = header
    	frame.objective    = objective
    	frame.completed    = completed
    end
    local Update = function()
        local watchID = 1
        for i = 1, GetNumQuestWatches() do
        	local qID = GetQuestIndexForWatch(i)
        	if  qID then
        		local n = GetNumQuestLeaderBoards(qID)
        		if  n > 0 then
        			local header = _G['QuestWatchLine'..watchID]
        			local group = {}
        			local completed = 0

                    watchID = watchID + 1

        			for j = 1, n do
        				local _, _, finished  = GetQuestLogLeaderBoard(j, qID)
        				if  finished then
        					completed = completed + 1
        				end
        				tinsert(group, _G['QuestWatchLine'..watchID])
        				watchID = watchID + 1
        			end
        			CreateClickFrame(i, qID, header, group, completed == n)
                end
        	end
        end
        for _, v in pairs(f) do
        	v[GetQuestIndexForWatch(v.watchID) and 'Show' or 'Hide'](v)
        end
    end

    local OnEvent = function()
            hooksecurefunc('QuestWatch_Update', Update)
    end
    local e = CreateFrame'Frame'
    e:RegisterEvent'PLAYER_LOGIN'
    e:SetScript('OnEvent', OnEvent)

	
