--[[
##########################################################
Inked! by: keivamp
##########################################################
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local _, ns = ...
local oUF = ns.oUF
local _, playerClass = UnitClass("player")
local addonName, addon = ...

-----------------------------
-- functions
-----------------------------
-- Backdrop function, this is also how we cheese borders on things
local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
	
end
local function CreateRaidBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function CreatePowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0.25,0.25,0.25,0.75)
	
end

------------------------------------------------------------------
-- Shared settings
------------------------------------------------------------------------
local function Shared(self, unit, isSingle)
		
	unit = gsub(unit, "%d", "")

	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	
	--self:SetWidth(120)
	--self:SetHeight(50)
	--CreateRaidBackdrop(self)

	
	local Health = CreateFrame("StatusBar", nil, self)
	Health:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	

	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetHeight(40)

	CreateBackdrop(Health)
	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	
	--end
	 local Power = CreateFrame("StatusBar", nil, Health)
	Power:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	Power:SetHeight(10)
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-10)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	
	CreatePowerBackdrop(Power)
	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC 
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg
	
	-----------------------------
	--Text

	--Name
	local NameText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	NameText:SetPoint("TOP",Health,0,-4) -- but anchor to the base element so it doesn't wiggle
	NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 13, "OUTLINE")
	NameText:SetJustifyH("CENTER")
	NameText:SetWidth(120)
	self:Tag(NameText, "[name]") -- oUF will automagically update it!
	Health.text = NameText
	--Health Percent
	local HealthText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	HealthText:SetPoint("CENTER",Health,0,-10) -- but anchor to the base element so it doesn't wiggle
	HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 11, "OUTLINE")
	HealthText:SetJustifyH("CENTER")
	self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!
	Health.text = HealthText

	-----------------------------
	-- Rez Icon
	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(16, 16)
	ResurrectIcon:SetPoint('CENTER', self.Health)
   
	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	-----------------------------
	-- Raid icons
	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(16, 16)
	RaidTargetIndicator:SetPoint('CENTER', self.Health)
	
	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator
	
	-----------------------------
	-- Raid Roles
	-- Position and size
	local RaidRoleIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidRoleIndicator:SetSize(12, 12)
	RaidRoleIndicator:SetPoint('TOPLEFT')
   
	-- Register it with oUF
	self.RaidRoleIndicator = RaidRoleIndicator
	
   	------------------------
	-- Plugin: oUF_Smooth --
	------------------------
	
		self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end
	
   
   	----------------------------
	-- Plugin: oUF_SpellRange --
	----------------------------
	
	self.SpellRange = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	--Range
	if unit == "pet" or unit == "party" or unit == "partypet" then
		self.Range = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	end
	----------------------------
	-- Plugin: oUF_RaidDebuff --
	----------------------------
	
	local dbh = self:CreateTexture(nil, "OVERLAY")
	dbh:SetAllPoints(self)
	dbh:SetTexture("cfg.statusbar_texture")
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0) -- set alpha to 0 to hide the texture
	self.DebuffHighlightBackdrop = true
	self.DebuffHighlight = dbh
	
	
	
end

--Spawn Frames
oUF:RegisterStyle('keivampGroup', Shared)
oUF:Factory(function(self)

	self:SetActiveStyle'keivampGroup'
	--	local raid = self:SpawnHeader(nil, nil, 'raid,party,solo',
   --    'showRaid', false,
   --     'showSolo', false,
   --     'showPlayer', true,
   --     'showParty', true,
   --     'yOffset', -5
	--):SetPoint('TOPLEFT', UIParent,'TOPLEFT', 30, -120)
	local party = self:SpawnHeader(
    nil, nil, 'party,solo',
    'showParty', true,
    'showPlayer', true,
    'showSolo', false,
    'xOffset', 0,
    'yoffset', -5,
   'oUF-initialConfigFunction', [[
        self:SetHeight(50)
        self:SetWidth(120)
    ]],
    'maxColumns', 5,
    'unitsperColumn', 1,
    'columnSpacing', 5,
    'columnAnchorPoint', "TOP"
)

party:SetPoint('TOPLEFT', UIParent,'TOPLEFT', 30, -120)



end)