--[[
##########################################################
Inked! by: keivamp
##########################################################
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local _, ns = ...
local oUF = ns.oUF
local _, playerClass = UnitClass("player")
local _, targetClass = UnitClass("target")
local addonName, addon = ...
--UF 3
local NumberFontPlayer = [["Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"]]

local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status"})
    frame:SetBackdropColor(1,0,0,0.65)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0.25,0.25,0.75,0.75)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateClassPowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(1,.5,.5,1)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local UnitSpecific = {
	player = function(self)
	
		--------------------
		--  Player Set Up --
		--------------------	
		
		local PlayerWidth = 225;
		local PlayerHeight = 65;
		self:SetSize(PlayerWidth,PlayerHeight)
		
		---------------------------
		--  Player Graphic Frame --
		---------------------------	
		
		local MyPlayerFrame = CreateFrame("Frame",nil,self)
		MyPlayerFrame:SetFrameLevel(10)
		MyPlayerFrame:SetWidth(PlayerWidth) -- Set these to whatever height/width is needed 
		MyPlayerFrame:SetHeight(PlayerHeight+5) -- for your Texture
		MyPlayerFrame:SetScale(1.5)
		MyPlayerFrame:SetPoint("CENTER",-33,10)
		MyPlayerFrame:SetAlpha(1)
		local MyPlayerFrametex = MyPlayerFrame:CreateTexture(nil, "BACKGROUND")
		MyPlayerFrametex:SetAllPoints()
		MyPlayerFrametex:SetColorTexture(0, 0, 0, .25)
		
		------------------------------
		--  Player Graphic Textures --
		------------------------------	
		
		if UnitClass("player") == "Paladin" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaPaladin")
		end
		if UnitClass("player") == "Death Knight" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaDeathKnight")
		end
		if UnitClass("player") == "Demon Hunter" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaDemonHunter")
		end
		if UnitClass("player") == "Druid" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaDruid")
		end
		if UnitClass("player") == "Hunter" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaHunter")
		end
		if UnitClass("player") == "Mage" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMage")
		end
		if UnitClass("player") == "Rogue" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaRogue")
		end
		if UnitClass("player") == "Shaman" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaShaman")
		end
		if UnitClass("player") == "Warlock" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaWarlock")
		end
		if UnitClass("player") == "Monk" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonk")
		end
		if UnitClass("player") == "Warrior" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaWarrior")
		end
		if UnitClass("player") == "Priest" then
			MyPlayerFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaPriest")
		end
		
		----------------------
		--  Player Level --
		----------------------	
		
		local LevelText = MyPlayerFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", MyPlayerFrame, 2,-5) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF",11,"OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
	
		------------------
		--  Player Name --
		------------------		
		
		local NameText = MyPlayerFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOP", MyPlayerFrame, 0,-3) -- but anchor to the base element so it doesn't wiggle
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 14, "OUTLINE")
		NameText:SetWidth(200)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		--------------------------
		--  Player Power Values --
		--------------------------	
		
		local PowerText = MyPlayerFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", MyPlayerFrame, -10,-25) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!

		local PowerText2 = MyPlayerFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", MyPlayerFrame, 80,-25) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		
		local PowerText3 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText3:SetPoint("CENTER", self, 0,-21) -- but anchor to the base element so it doesn't wiggle
		PowerText3:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText3, "[curpp]") -- oUF will automagically update it!
		PowerText3:SetAlpha(0)
		
		local function UltraFunction()
					if(select(2, UnitClass('player')) == 'WARRIOR') or (select(2, UnitClass('player')) == 'ROGUE') or (select(2, UnitClass('player')) == 'DRUID')  then 
						if(select(2, UnitClass('player')) == 'DRUID') then 
							local form = GetShapeshiftFormID()
							if (form == BEAR_FORM or form == CAT_FORM) then
								PowerText3:SetAlpha(1)
								self:Tag(PowerText3, "[curpp]")
								PowerText2:SetAlpha(0) 
								PowerText:SetAlpha(0) 
								else
								local MaxMana = UnitPowerMax("player", 0)
								local Mana = UnitPower("player", 0)
								local druidPercent = math.floor(Mana / MaxMana * 100 + .5)
								self:Tag(PowerText2, "")
								self:Tag(PowerText, "")
								PowerText3:SetAlpha(0)
								PowerText2:SetAlpha(1) 
								PowerText2:SetText(Mana)
								PowerText:SetAlpha(1)
								PowerText:SetText(druidPercent)										
							end
						elseif(select(2, UnitClass('player')) == 'WARRIOR') then 
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0) 
							PowerText:SetAlpha(0) 
						elseif(select(2, UnitClass('player')) == 'ROGUE') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0) 
							PowerText:SetAlpha(0) 							
						end	
					else
						PowerText3:SetAlpha(0)
						PowerText2:SetAlpha(1) 
						PowerText:SetAlpha(1) 
					end
				end
		local UltraEvent = CreateFrame("FRAME")
		UltraEvent:HookScript("OnUpdate", UltraFunction)
		
		---------------------------
		--  Player Health Values --
		---------------------------		
		
		local HealthText = MyPlayerFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", MyPlayerFrame, -10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = MyPlayerFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", MyPlayerFrame, 80,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!
		----------------------
		--  Player Portrait --
		----------------------		
			
		self.Portrait:SetPoint('CENTER', MyPlayerFrame, 'LEFT',60,-15)
		self.Portrait:SetSize(95, 65)
		
		----------------------
		--  Player Cast Bar --
		----------------------		
		
		self.Health:SetHeight(45)
		self.Power:SetHeight(20)
		
		----------------------
		--  Player Cast Bar --
		----------------------
		
		self.Castbar:SetSize(305, 25)
		self.Castbar:SetPoint('BOTTOMRIGHT', self.Health, 0, -50)
		
		------------------
		--  Player Aura --
		------------------
		if Inked.db.char.PlayerAuraIcons == true then
			local Auras = CreateFrame("Frame", nil, self)
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,60)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 60)
			Auras:SetHeight(30)
			Auras:SetHeight(30 + 4)

			Auras.size = 30
			Auras.onlyShowPlayer = false
			Auras.gap = 5
			Auras.spacing = 4
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16
			
			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
			end
		-------------------------
		--  Player Combat Icon --
		-------------------------

		
		local CombatAlertFrame = CreateFrame("Frame")
		CombatAlertFrame:SetSize(32,32)
		CombatAlertFrame:SetPoint("RIGHT", self, 32,0)
		CombatAlertFrame:Hide()
		CombatAlertFrame.Bg = CombatAlertFrame:CreateTexture(nil, "BACKGROUND")
		CombatAlertFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\combat")
		CombatAlertFrame.Bg:SetPoint("RIGHT", self, 32,0)
		CombatAlertFrame.Bg:SetSize(32, 32)


		CombatAlertFrame:SetScript("OnEvent", function(self, event, ...)
			if (event == "PLAYER_REGEN_DISABLED") then
				CombatAlertFrame:Show()
			elseif (event == "PLAYER_REGEN_ENABLED") then
				CombatAlertFrame:Hide()
			end
		end)
		CombatAlertFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
		CombatAlertFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
		-----------------------
		--  Player Rest Icon --
		-----------------------
		
	local CombatRestFrame = CreateFrame("Frame")
	CombatRestFrame:SetSize(32, 32)
	CombatRestFrame:SetPoint("CENTER",self,"CENTER",-PlayerWidth/2,PlayerHeight/2)
	CombatRestFrame:Hide()
	CombatRestFrame.Bg = CombatRestFrame:CreateTexture(nil, "BACKGROUND")
	CombatRestFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\resting")
	CombatRestFrame.Bg:SetPoint("CENTER",self,"CENTER",-170,PlayerHeight/2)
	CombatRestFrame.Bg:SetSize(32, 32)

	function RestMe()
		if IsResting() == true then
			CombatRestFrame:Show()	
		end
		if IsResting() == false then
			CombatRestFrame:Hide()
		end
	end
	local RestMeframe = CreateFrame("Frame")
	RestMeframe:HookScript("OnUpdate", RestMe)
	---swing Bar ---
		
			-- Position and size
			if Inked.db.char.SwingTimer== true then 
			self.Swing = CreateFrame('StatusBar', nil, self)
			self.Swing:SetPoint('TOP', self.Power, 'BOTTOM', -50, -35)
			self.Swing:Hide()

			self.Swing:SetHeight(20)
			self.Swing:SetWidth(305)
			

			self.Swing.Text = self.Swing:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmall')
			self.Swing.Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 12, "OUTLINE")
			self.Swing.Text:SetPoint('CENTER', self.Swing)
			--CreateBackdrop(self.Swing)
			
				self.Swing:SetScript("OnEvent", function(self, event, ...)
				if (event == "PLAYER_REGEN_DISABLED") then
				self:Show()
				elseif (event == "PLAYER_REGEN_ENABLED") then
				self:Hide()
				end
				end)
				self.Swing:RegisterEvent("PLAYER_REGEN_ENABLED")
				self.Swing:RegisterEvent("PLAYER_REGEN_DISABLED")
				
			end
			---Main Hand Enchants --
			self.Enchant = CreateFrame('Frame',  nil, self)
			self.Enchant:SetHeight(30)
			self.Enchant:SetWidth(30 + 4)
			self.Enchant:SetPoint('TOPLEFT', self, 'TOPLEFT', -175, -38)
			self.Enchant.showCD = false
			self.Enchant.size = 30
			self.Enchant.spacing = 4
			self.Enchant.initialAnchor = 'TOPLEFT'
			self.Enchant['growth-y'] = 'RIGHT'
			
			self.Enchant.showBlizzard = true
			
			self.PostCreateEnchantIcon = enchantIcon
			self.PostUpdateEnchantIcons = enchantUpdateIcons
			
		------------------
		--  Player Shaman Totems --
		------------------		
	if select(2, UnitClass'player') == "SHAMAN" then
		local w, h = 45, 16
		local tb = {
			AbbreviateNames = true,
			Destroy = true,
			UpdateColors = true,
		}
		for i = 1, 4 do
			local t = CreateFrame('Frame', nil, self)
			t:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', (i - 1) * (50), 30)
			t:SetSize(w, h)
		
			local bg = t:CreateTexture(nil, 'BACKGROUND')
			bg:SetAllPoints()
			bg:SetTexture(1, 1, 1)
			bg.multiplier = 0.2
			t.bg = bg
		
			local bar = CreateFrame('StatusBar', nil, t)
			bar:SetPoint('RIGHT', -1, 0)
			bar:SetSize(30, 15)
			bar.Reverse = true
			t.StatusBar = bar
		
			local icon = t:CreateTexture(nil, 'ARTWORK')
			icon:SetPoint('LEFT', 1, 0)
			icon:SetSize(h - 2, h - 2)
			icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
			t.Icon = icon
		
			local time = bar:CreateFontString(nil, 'OVERLAY')
			time:SetPoint('RIGHT', -1, 0)
			time:SetFontObject'GameFontNormal'
			time:SetJustifyH'RIGHT'
			t.Time = time
		
			local text = bar:CreateFontString(nil, 'OVERLAY')
				text:SetPoint('LEFT', 1, 0)
			text:SetPoint('RIGHT', time, 'LEFT', -2, 0)
			text:SetFontObject'GameFontNormal'
			text:SetJustifyH'LEFT'
			t.Text = text
		
			tb[i] = t
			end
		self.TotemBar = tb
	end
		----------------------------------------------
		--  Player Spell Range (oUF_SpellRange.lua) --
		----------------------------------------------
		
		 self.Range = {
        insideAlpha = 1,
        outsideAlpha = 1/2,
		    }
				
		----------------------
		--  Player PVP Icon --
		----------------------

		
		local PVPFrame = CreateFrame("Frame")
		PVPFrame:SetSize(32, 32)
		PVPFrame:SetPoint("LEFT",self,"LEFT", -32,0); 
		PVPFrame:Hide()
		PVPFrame.Bg = PVPFrame:CreateTexture(nil, "BACKGROUND")
		PVPFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87	
		end
		PVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.75);
		PVPFrame.Bg:SetPoint("LEFT",self,"LEFT", -110,-10); 
		PVPFrame.Bg:SetSize(40, 40)		
		function PlayerPVPMe()
			if UnitIsPVP("player") then	
				PVPFrame:Show()
			else
				PVPFrame:Hide()
			end
		
		end
		local PlayerPVPMeframe = CreateFrame("Frame")
		PlayerPVPMeframe:HookScript("OnUpdate", PlayerPVPMe)
		
	--	 druid Extra Manabar
	if Inked.db.char.DruidManaBar == true then
	local DruidClassicManaframe = CreateFrame("Frame",nil,UIParent)
	DruidClassicManaframe:SetSize(305, 15)
	DruidClassicManaframe:SetPoint("CENTER",self.Power,"CENTER",-50,-78)
	DruidClassicManaframe:Hide()
	DruidClassicManaframe.bar = CreateFrame("StatusBar", nil, DruidClassicManaframe)
	DruidClassicManaframe.bar:SetPoint("TOPLEFT", 0, 0)
	DruidClassicManaframe.bar:SetPoint("TOPRIGHT", 0, 0)
	DruidClassicManaframe.bar:SetHeight(19)
	DruidClassicManaframe.bar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	DruidClassicManaframe.bar:GetStatusBarTexture():SetHorizTile(false)
	DruidClassicManaframe.bar:GetStatusBarTexture():SetVertTile(false)
	DruidClassicManaframe.bar:SetStatusBarColor(0.2,0.25,0.75,1)
	
		local DBPowerText = DruidClassicManaframe.bar:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		DBPowerText:SetPoint("RIGHT", DruidClassicManaframe.bar, -10,0) -- but anchor to the base element so it doesn't wiggle
		DBPowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 12, "OUTLINE")		
		local DBPowerText2 = DruidClassicManaframe.bar:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		DBPowerText2:SetPoint("LEFT", DruidClassicManaframe.bar, 10,0) -- but anchor to the base element so it doesn't wiggle
		DBPowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 12, "OUTLINE")
		--DBPowerText2:SetText(UnitPower("player", 0))
			local function UltraFunction2()
			
				if(select(2, UnitClass('player')) == 'DRUID') then 
					local form = GetShapeshiftFormID()
						if (form == BEAR_FORM or form == CAT_FORM) then
						CreatePowerBackdrop(DruidClassicManaframe)
						DruidClassicManaframe.bar:Show()
						DBPowerText2:SetText(UnitPower("player", 0))
							local MaxMana = UnitPowerMax("player", 0)
							local Mana = UnitPower("player", 0)
							--local druidPercent = math.floor(Mana / MaxMana * 100 + .5)
							DBPowerText:SetText(MaxMana)
							DruidClassicManaframe.bar:SetMinMaxValues(min(0, Mana), MaxMana)
							DruidClassicManaframe.bar:SetValue(Mana)
					else
						DruidClassicManaframe:Hide()

					end
					if (select(2, UnitClass('player')) ~= 'DRUID') then DruidClassicManaframe:Hide() end
				end
			end
		
	local UltraEvent2 = CreateFrame("FRAME")
	UltraEvent2:HookScript("OnUpdate", UltraFunction2)
	
		local function UltraFunction()
		if(select(2, UnitClass('player')) ~= 'DRUID') then return end
				if(select(2, UnitClass('player')) == 'DRUID') then 
					local form = GetShapeshiftFormID()
						if (form == BEAR_FORM or form == CAT_FORM) then
							--CreateBackdrop(DruidClassicManaframe)
							DruidClassicManaframe:Show()
							else
							DruidClassicManaframe:Hide()
						end
					
				end
			end
	
	local UltraEvent = CreateFrame("FRAME")
	UltraEvent:HookScript("OnUpdate", UltraFunction)
	end		
		--- Classic Combo Points ---	
			
			local function CreateComboBackdrop(frame)
			frame:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Textures\\Action Bars\\DruidBTN",
			insets = {top = -2, left = -2, bottom = -2, right = -2}})
			frame:SetBackdropColor(1,0.49,0.04, 1)
			frame:SetBackdropBorderColor(1,0.96,0.41,1)
			end
			local ClassicComboframe = CreateFrame("Frame", nil, UIParent)
			ClassicComboframe:SetSize(175, 20)
			ClassicComboframe:SetPoint("CENTER",self.Health,"CENTER",0,65)

			local ClassicComboPointframe = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe:SetSize(30, 15)
			ClassicComboPointframe:SetPoint("LEFT",ClassicComboframe,"LEFT",0,0)
			local Frametex = ClassicComboPointframe:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe)
			ClassicComboPointframe:Hide()
	
	
			local ClassicComboPointframe2 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe2:SetSize(30, 15)
			ClassicComboPointframe2:SetPoint("LEFT",ClassicComboPointframe,"LEFT",35,0)
			local Frametex = ClassicComboPointframe2:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe2)
	
			local ClassicComboPointframe3 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe3:SetSize(30, 15)
			ClassicComboPointframe3:SetPoint("LEFT",ClassicComboPointframe,"LEFT",70,0)
			local Frametex = ClassicComboPointframe3:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe3)
			
			local ClassicComboPointframe4 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe4:SetSize(30, 15)
			ClassicComboPointframe4:SetPoint("LEFT",ClassicComboPointframe,"LEFT",105,0)
			local Frametex = ClassicComboPointframe4:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe4)
			
			local ClassicComboPointframe5 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe5:SetSize(30, 15)
			ClassicComboPointframe5:SetPoint("LEFT",ClassicComboPointframe,"LEFT",140,0)
			local Frametex = ClassicComboPointframe5:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe5)

	
	--local combo = GetComboPoints("player", "target")
	local function MyCombo()
	if UnitClass("player") ~= "Druid" or UnitClass("player") ~= "Rogue"  then
			ClassicComboframe:Hide()
	end
	local form = GetShapeshiftFormID()
		if (form == CAT_FORM) then
			ClassicComboframe:Show()
		else
			ClassicComboframe:Hide()
		end
	local combo = GetComboPoints("player", "target")
	--print(combo)
		if combo > 0 then
			--print(combo)
			ClassicComboPointframe:Show()
			else
			ClassicComboPointframe:Hide()
		
		end
		if combo > 1 then
			--print(combo)
			ClassicComboPointframe2:Show()
			else
			ClassicComboPointframe2:Hide()
		end
		if combo > 2 then
			--print(combo)
			ClassicComboPointframe3:Show()
			else
			ClassicComboPointframe3:Hide()
		end
		if combo > 3 then
			--print(combo)
			ClassicComboPointframe4:Show()
			else
			ClassicComboPointframe4:Hide()
		end
		if combo > 4 then
			--print(combo)
			ClassicComboPointframe5:Show()
			else
			ClassicComboPointframe5:Hide()
		end
	end
		
	local MyComboFrame = CreateFrame("Frame", nil, UIParent)
	MyComboFrame:RegisterEvent("PLAYER_TARGET_CHANGED",MyDruidCombo)
	MyComboFrame:HookScript("OnUpdate", MyCombo)
		--[[
		if(select(2, UnitClass('player')) ~= 'ROGUE') then 
				return
			else
			local ClassPower = {}
			for index = 1, 10 do
			local Bar = CreateFrame('StatusBar', nil, self)
			Bar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
			CreateClassPowerBackdrop(Bar)
		
        -- Position and size.
			Bar:SetSize(20, 20)
			Bar:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', (index - 1) * (Bar:GetWidth()+10), -10)

			ClassPower[index] = Bar
			end

		-- Register with oUF
		self.ClassPower = ClassPower
		end 
		 ]]--
	end,-- End Player
		boss = function(self)
	self:SetSize(225,65)
		
		
		self.Portrait:SetPoint('TOPRIGHT', self.Health, 'TOPLEFT', 0,0)
		self.Portrait:SetSize(65, 65)
		
		self.Health:SetHeight(65-20)
		self.Power:SetHeight(65-45)
		
		self.Castbar:SetSize(225+65, 25)
		self.Castbar:SetPoint('BOTTOM', self.Power, -32, -27)
		

	
	end, --end boss
	pet = function(self)
		-- pet specific stuff
		---------------------------
		--  Player Pet Set Up  --
		---------------------------
		
		self:SetSize(145,40)
		
		--------------------------------
		--  Player Pet Graphic Frame  --
		--------------------------------	
		
		local MyPet = CreateFrame("Frame",nil,self)
		MyPet:SetFrameLevel(10)
		MyPet:SetWidth(135) -- Set these to whatever height/width is needed 
		MyPet:SetHeight(40) -- for your Texture
		MyPet:SetScale(1.7)
		MyPet:SetPoint("CENTER",-19,3)
		MyPet:SetAlpha(1)
		local MyPettex = MyPet:CreateTexture(nil, "BACKGROUND")
		MyPettex:SetAllPoints()
		MyPettex:SetColorTexture(0, 0, 0, .25)
		
		------------------------------
		--  Player Pet Graphic Set  --
		------------------------------
		
		if UnitClass("player") == "Hunter" then
			MyPettex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaHunter")
				
		end
		if UnitClass("player") == "Mage" then
			MyPettex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMage")
				
		end
		if UnitClass("player") == "Death Knight" then
			MyPettex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaDeathKnight")
				
		end
		if UnitClass("player") == "Warlock" then
			MyPettex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaWarlock")
				
		end
		------------------------
		--  Player Pet Level  --
		------------------------
		
		local LevelText = MyPet:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("LEFT", MyPet, -20,15) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 11, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		
		---------------------------
		--  Player Pet Name  --
		---------------------------
		
		local NameText = MyPet:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", MyPet, 0,2) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 10, "OUTLINE")
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		-------------------------------
		--  Player Pet Power Values  --
		-------------------------------		
		
		local PowerText = MyPet:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", MyPet, -10,-13) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!

		local PowerText2 = MyPet:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", MyPet, 45,-13) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		
		--------------------------------
		--  Player Pet Health Values  --
		--------------------------------
		
		local HealthText = MyPet:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", MyPet,-10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = MyPet:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", MyPet, 45,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!

		---------------------------
		--  Player Pet Portrait  --
		---------------------------		
		
		self.Portrait:SetPoint('CENTER', MyPet, 'LEFT', 35,-8)
		self.Portrait:SetSize(55, 45)
		
		-----------------------------------------------
		--  Player Pet Health and Power Adjustments  --
		-----------------------------------------------		
		
		self.Health:SetHeight(25)
		self.Power:SetHeight(20)
		
		-------------------------
		--  Player Pet Set Up  --
		-------------------------	
		
		self.Health:SetHeight(25)
		self.Power:SetHeight(20)
		
		------------------------------------------------------
		--  Player Pet Cast Bar (Not Availible in Classic)  --
		------------------------------------------------------	
		
		self.Castbar:SetPoint('CENTER', UIParent, 0, -60)
		self.Castbar:SetSize(135, 15)
		
		------------------------
		--  Player Pet Auras  --
		------------------------	
		if Inked.db.char.PlayerAuraIcons == true then
		local Auras = CreateFrame("Frame", nil, self)
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
			Auras:SetHeight(20)
			Auras:SetHeight(20 + 4)

			Auras.size = 20
			Auras.onlyShowPlayer = false
			Auras.gap = 5
			Auras.spacing = 4
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
			end
			local PetHappiness = CreateFrame('Frame', nil, self)
			PetHappiness:SetSize(32, 32)
			PetHappiness:SetPoint('LEFT', self, 'LEFT',-110,-10)

			-- Register it with oUF
			self.PetHappiness = PetHappiness
		
	end,-- End Pet
	target = function(self)
		
		--------------------
		--  Target Set Up --
		--------------------
		
		self:SetSize(235,65)
		
		---------------------------
		--  Target Graphic Frame --
		---------------------------
		
		local MyTargetFrame = CreateFrame("Frame",nil,self)
		MyTargetFrame:SetFrameLevel(10)
		MyTargetFrame:SetWidth(235) -- Set these to whatever height/width is needed 
		MyTargetFrame:SetHeight(70) -- for your Texture
		MyTargetFrame:SetScale(1.5)
		MyTargetFrame:SetPoint("CENTER",33,10)
		MyTargetFrame:SetAlpha(1)
		local MyTargetFrametex = MyTargetFrame:CreateTexture(nil, "BACKGROUND")
		MyTargetFrametex:SetAllPoints()
		MyTargetFrametex:SetColorTexture(0, 0, 0, .25)
		MyTargetFrametex:SetTexCoord(1, 0, 0,1)
		
		local MyTargetStylerFrame = CreateFrame("Frame")
		MyTargetStylerFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
	
	function MyTargetStylerFrame:OnEvent(event, ...)
	
		---------------------------
		--  Detect Target Change --
		---------------------------
		
		if event == "PLAYER_TARGET_CHANGED" then
		
				-----------------------------
				--  Change Target Graphics --
				-----------------------------
				
				if UnitClass("target") == "Paladin" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaPaladin")
				end
				if UnitClass("target") == "Death Knight" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaDeathKnight")
				end
				if UnitClass("target") == "Demon Hunter" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaDemonHunter")
				end
				if UnitClass("target") == "Druid" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaDruid")
				end
				if UnitClass("target") == "Hunter" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaHunter")
				end
				if UnitClass("target") == "Mage" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMage")
				end
				if UnitClass("target") == "Rogue" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaRogue")
				end
				if UnitClass("target") == "Shaman" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaShaman")
				end
				if UnitClass("target") == "Warlock" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaWarlock")
				end
				if UnitClass("target") == "Monk" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonk")
				end
				if UnitClass("target") == "Warrior" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaWarrior")
				end
				if UnitClass("target") == "Priest" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaPriest")
				end
				
				---------------------------
				--  Shape Shifted Druids --
				---------------------------
				
				if UnitCreatureType("target") == "Beast" and UnitClass("target") ~= "Druid" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				
				--------------------
				--  Ghost Wolf  --
				--------------------	
				
				if UnitCreatureType("target") == "Beast" and UnitClass("target") == "Shaman" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaShaman")
				end
				if UnitCreatureType("target") == "Non-combat Pet" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Not specified" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Critter" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Demon" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Dragonkin" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Elemental" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Gas Cloud" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Giant" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Mechanical" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Totem" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Undead" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Wild Pet" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				if UnitCreatureType("target") == "Aberration" then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaMonster")
				end
				
				--------------------
				--  NPC --
				--------------------
				
				if UnitCreatureType("target") == "Humanoid" and UnitRace("target") == nil then
						MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaNPC")
				end
				--------------------
				--  Elite Units --
				--------------------
				
				if UnitClassification("target") == "elite"  then
					MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaSilverElite")
				end
				if UnitClassification("target") == "rare"  then
						MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaRare")
				end
				if UnitClassification("target") == "rareelite"  then
						MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaRareElite")
				end
		
				if UnitClassification("target") == "worldboss"  then
						MyTargetFrametex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\AlphaGoldElite")
				end
			end
		end
		MyTargetStylerFrame:SetScript("OnEvent", MyTargetStylerFrame.OnEvent)
		
		-------------------------------------
		--  Adjust Target Health and Power --
		-------------------------------------
		
		self.Health:SetHeight(45)
		self.Power:SetHeight(20)
		
		-------------------------
		--  Target Level Value --
		-------------------------
		
		local LevelText = MyTargetFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("RIGHT", MyTargetFrame, 20,-5) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 11, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		
		-------------------------
		--  Target Name Value --
		-------------------------	
		
		local NameText = MyTargetFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", MyTargetFrame, 0,-3) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 14, "OUTLINE")
		NameText:SetWidth(400)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		-------------------------
		--  Target Power Value --
		-------------------------	
		
		local PowerText = MyTargetFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", MyTargetFrame, -80,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!

	
		local PowerText2 = MyTargetFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", MyTargetFrame, 10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
				
		--------------------------
		--  Target Health Value --
		--------------------------
		
		local HealthText = MyTargetFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", MyTargetFrame, -80,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = MyTargetFrame:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", MyTargetFrame, 10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 10, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!
		
		----------------------
		--  Target Portrait --
		----------------------
		
		self.Portrait:SetPoint('CENTER', MyTargetFrame, 'RIGHT', -60,-15)
		self.Portrait:SetSize(95, 65)
		
		-----------------------
		--  Target Cast bar --
		-----------------------	
		
		self.Castbar:SetSize(315, 25)
		self.Castbar:SetPoint('BOTTOMLEFT', self.Health, 20, -60)
		
		-----------------------------
		-- Target Auras
		-----------------------------
		if Inked.db.char.PlayerAuraIcons == true then
		local Auras = CreateFrame("Frame", nil, self)
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,45)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 45)
		Auras:SetHeight(30)
		Auras:SetHeight(30 + 4)

		Auras.size = 30
		Auras.onlyShowPlayer = false
		Auras.gap = 5
		Auras.spacing = 4
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 16

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
		end
			-----------------
		--  Target Floating Combat Text--
		-----------------		
		if Inked.db.char.InkedFloatingCombatText == true then
		local fcf = CreateFrame("Frame", nil, self)
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",-40,200)
 
		for i = 1, 6 do
			-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
 
		fcf.font = "Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"
		fcf.fontHeight = 24
		fcf.fontFlags = "OUTLINE"

		self.FloatingCombatFeedback = fcf
		end
		-----------------
		--  Target PVP --
		-----------------	
		
		local TargetPVPFrame = CreateFrame("Frame")
		TargetPVPFrame:SetSize(32, 32)
		TargetPVPFrame:SetPoint("RIGHT", self, 32,0); 
		TargetPVPFrame:Hide()
		TargetPVPFrame.Bg = TargetPVPFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87	
		end
		TargetPVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetPVPFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		TargetPVPFrame.Bg:SetPoint("RIGHT", self, 125,10); 
		TargetPVPFrame.Bg:SetSize(32, 32)		
		function PVPMe()
			if UnitIsPVP("target") then	
				TargetPVPFrame:Show()
			else
				TargetPVPFrame:Hide()
			end
		
		end
		local PVPMeframe = CreateFrame("Frame")
		PVPMeframe:HookScript("OnUpdate", PVPMe)
		
	end, -- End Target
	targettarget = function(self)
		self:SetSize(165,35)
		
		------------------------------------
		-- Target of Target Graphic Frame --
		------------------------------------	
		
		local Mytargettarget = CreateFrame("Frame",nil,self)
		Mytargettarget:SetFrameLevel(10)
		Mytargettarget:SetWidth(150) -- Set these to whatever height/width is needed 
		Mytargettarget:SetHeight(45) -- for your Texture
		Mytargettarget:SetScale(1.7)
		Mytargettarget:SetPoint("CENTER",20,3)
		Mytargettarget:SetAlpha(1)
		
		local Mytargettargettex = Mytargettarget:CreateTexture(nil, "BACKGROUND")
		Mytargettargettex:SetAllPoints()
		Mytargettargettex:SetColorTexture(0, 0, 0, .25)
		Mytargettargettex:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\TargetTarget")
		Mytargettargettex:SetTexCoord(1, 0, 0,1)
		
		----------------------------------
		-- Target of Target Level Text --
		----------------------------------	
		
		local LevelText = Mytargettarget:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("RIGHT", Mytargettarget, 20,-5) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 11, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		
		---------------------------------
		-- Target of Target Neame Text --
		---------------------------------	
		
		local NameText = Mytargettarget:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", Mytargettarget, 0,2) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 10, "OUTLINE")
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		----------------------------------
		-- Target of Target Power Value --
		----------------------------------
		
		local PowerText = Mytargettarget:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", Mytargettarget, -50,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!
		PowerText:SetAlpha(1)
		
		local PowerText2 = Mytargettarget:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", Mytargettarget, 10,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		PowerText2:SetAlpha(1)
		
		
		
		-----------------------------------
		-- Target of Target Health Value --
		-----------------------------------
		
		local HealthText = Mytargettarget:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", Mytargettarget, -50,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!
		
		local HealthText2 = Mytargettarget:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", Mytargettarget, 10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!
		
		-------------------------------
		-- Target of Target Portrait --
		-------------------------------
		
		self.Portrait:SetPoint('CENTER', Mytargettarget, 'RIGHT', -40,-8)
		self.Portrait:SetSize(65, 45)
		
		-------------------------------------------------------
		-- Target of Target Health and Power Bar Adjustments --
		-------------------------------------------------------	
		
		self.Health:SetHeight(25)
		self.Power:SetHeight(20)
		
		-------------------------------
		-- Target of Target Cast Bar --
		-------------------------------
		
		self.Castbar:Hide()
		
	end, -- End Target of Target	
}
	UnitSpecific.arena = UnitSpecific.boss 

local Shared = function(self, unit)
	-- Shared layout code.
	
	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------
	
	local Health = CreateFrame("StatusBar", nil, self)
	Health:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	CreateHealthBackdrop(Health)
	
	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg
	
   -------------------------
	--  Health Prediction --
	------------------------
	
   -- Register with oUF
		self.HealthPrediction = {
		myBar = myBar,
		otherBar = otherBar,
		absorbBar = absorbBar,
		healAbsorbBar = healAbsorbBar,
		maxOverflow = 1.05,
		frequentUpdates = true,
   }
    -----------------
	--  Power Bars --
	-----------------
	
	local Power = CreateFrame("StatusBar", nil, Health)
	Power:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-20)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	
	CreatePowerBackdrop(Power)
	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC 
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg
	
	------------------
	--   Portrait --
	------------------



	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self)
	
	CreateBackdrop(Portrait)
	 Portrait:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Assets\\Buttons\\UNIT-BG13",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		Portrait:SetBackdropColor(0.35,0.35,0.35,0.75)
		
	-- Register it with oUF
	self.Portrait = Portrait
	

	--------------
	-- Cast Bar --
	--------------
	
	-- Position and size
	local Castbar = CreateFrame("StatusBar", nil, self)
	Castbar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
	if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87	
	end
	Castbar:SetStatusBarColor(MyRed,MyGreen,MyBlue,0.75)
	

	-- Add a background
	CreateBackdrop(Castbar)
	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(25, 15)
	Spark:SetBlendMode("ADD")
   
	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
	Time:SetTextColor(0.95, 0.95, 0.95)
	Time:SetPoint("RIGHT", Castbar, -3, 1)
   
	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
	Text:SetTextColor(0.95, 0.95, 0.95)
	Text:SetPoint("LEFT", Castbar, 3, 1)
   
	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)
	
	local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
    Icon:SetSize(25, 25)
    Icon:SetPoint('LEFT', Castbar, 'LEFT',-25,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")
   
	-- Register it with oUF
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	self.Castbar.Icon = Icon
	
	-----------------
	-- Smooth Bars --
	-----------------
	
	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end
	
	--------------
	-- Rez Icon --
	--------------
	
	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(16, 16)
	ResurrectIcon:SetPoint('CENTER', self.Health)
   
	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	----------------
	-- Raid icons --
	----------------
	
	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(16, 16)
	RaidTargetIndicator:SetPoint('CENTER', self.Health)
	
	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator
   
	
   
	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("keivampLayout3", Shared)
oUF:Factory(function(self)
if Inked.db.char.UF3  == false then return end
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("keivampLayout3")
     self:Spawn("player"):SetPoint("CENTER",UIParent,"CENTER",-235,-250)
	 self:Spawn("target"):SetPoint("CENTER",UIParent,"CENTER",235,-250)
	 self:Spawn("pet"):SetPoint("CENTER",UIParent,"CENTER",-375,-375)
	 self:Spawn("targettarget"):SetPoint("CENTER",UIParent,"CENTER",375,-375)
	 self:Spawn("boss"):SetPoint("CENTER",UIParent,"CENTER",0,350)
 
end)

