--[[
##########################################################
Inked! by: keivamp
##########################################################
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local _, ns = ...
local oUF = ns.oUF
local _, playerClass = UnitClass("player")
local _, targetClass = UnitClass("target")
local addonName, addon = ...
--UF 2

local NumberFontPlayer = [["Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"]]
local ThisTexture = ("")
		if  UnitClass("player") == "Paladin" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\PallyRectFrames")
		end
		if  UnitClass("player") == "Death Knight" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DeathKnightRectFrames")
		end
		if  UnitClass("player") == "Demon Hunter" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DemonHunterRectFrames")
		end
		if  UnitClass("player") == "Druid" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DruidRectFrames")
		end
		if  UnitClass("player") == "Hunter" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\HunterRectFrames")
		end
		if  UnitClass("player") == "Mage" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\MageRectFrames")
		end
		if  UnitClass("player") == "Rogue" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\RogueRectFrames")
		end
		if  UnitClass("player") == "Shaman" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\ShamanRectFrames")
		end
		if  UnitClass("player") == "Warlock" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\WarlockRectFrames")
		end
		if  UnitClass("player") == "Monk" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\MonkRectFrames")
		end
		if  UnitClass("player") == "Warrior" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\WarriorRectFrames")
		end
		if  UnitClass("player") == "Priest" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Unit Frames\\PriestRectFrames")
		end

local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status"})
    frame:SetBackdropColor(0.25,0.25,0.25,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0.25,0.25,0.25,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = ThisTexture,
        insets = {top = -7, left = -7, bottom = -7, right = -7}})
		frame:SetBackdropColor(1,1,1,1)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateSpellBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0.15,0.15,0.15,0.65)
		frame:SetBackdropBorderColor(0.25,0.25,0.25,.65)
end

local function CreateClassPowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(1,.5,.5,1)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local UnitSpecific = {
	player = function(self)
	
		--------------------
		--  Player Set Up --
		--------------------	
		
		local PlayerWidth = 225;
		local PlayerHeight = 65;
		self:SetSize(PlayerWidth,PlayerHeight)
		CreateBackdrop(self)
		
		----------------------
		--  Player Level --
		----------------------	
		
		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", self, -35,-5) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF",14,"OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		LevelText:SetAlpha(1)
	
		------------------
		--  Player Name --
		------------------		
		
		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOP", self, 0,1) -- but anchor to the base element so it doesn't wiggle
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
		NameText:SetWidth(200)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		local NameText2 = self.Portrait:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText2:SetPoint("CENTER", NameText, -3,-3) -- but anchor to the base element so it doesn't wiggle
		NameText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
		NameText2:SetWidth(200)
		NameText2:SetTextColor(0,0,0,0.75)
		self:Tag(NameText2, "[name]") -- oUF will automagically update it!
		
		--------------------------
		--  Player Power Values --
		--------------------------	
		
		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!
		PowerText:SetAlpha(1) -- oUF will automagically update it!

		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		PowerText2:SetAlpha(1) -- oUF will automagically update it!
						
		local PowerText3 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText3:SetPoint("CENTER", self, 0,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText3:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText3, "[curpp]") -- oUF will automagically update it!
		PowerText3:SetAlpha(0)
		
		local function UltraFunction()
					if(select(2, UnitClass('player')) == 'WARRIOR') or (select(2, UnitClass('player')) == 'ROGUE') or (select(2, UnitClass('player')) == 'DRUID')  then 
						if(select(2, UnitClass('player')) == 'DRUID') then 
							local form = GetShapeshiftFormID()
							if (form == BEAR_FORM or form == CAT_FORM) then
								PowerText3:SetAlpha(1)
								self:Tag(PowerText3, "[curpp]")
								PowerText2:SetAlpha(0) 
								PowerText:SetAlpha(0) 
								else
								local MaxMana = UnitPowerMax("player", 0)
								local Mana = UnitPower("player", 0)
								local druidPercent = math.floor(Mana / MaxMana * 100 + .5)
								self:Tag(PowerText2, "")
								self:Tag(PowerText, "")
								PowerText3:SetAlpha(0)
								PowerText2:SetAlpha(1) 
								PowerText2:SetText(Mana)
								PowerText:SetAlpha(1)
								PowerText:SetText(druidPercent)										
							end
						elseif(select(2, UnitClass('player')) == 'WARRIOR') then 
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0) 
							PowerText:SetAlpha(0) 
						elseif(select(2, UnitClass('player')) == 'ROGUE') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0) 
							PowerText:SetAlpha(0) 							
						end	
					else
						PowerText3:SetAlpha(0)
						PowerText2:SetAlpha(1) 
						PowerText:SetAlpha(1) 
					end
				end
		local UltraEvent = CreateFrame("FRAME")
		UltraEvent:HookScript("OnUpdate", UltraFunction)

		
		
		---------------------------
		--  Player Health Values --
		---------------------------		
		
		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!
		----------------------
		--  Player Portrait --
		----------------------		
			
		self.Portrait:SetPoint('CENTER', self, 'CENTER',0,0)
		self.Portrait:SetSize(225, 65)
		self.Portrait:SetAlpha(0.45)
		--self.Portrait:SetBlendMode("ADD")
		
		------------------------------------------
		--  Player Health and Power Adjustments --
		------------------------------------------	
		
		self.Health:SetHeight(45)
		self.Power:SetHeight(22)
		self.Power:SetPoint('BOTTOM', self.Health,'BOTTOM', 0, -22)
		
		----------------------
		--  Player Cast Bar --
		----------------------
		
		self.Castbar:SetSize(213, 15)
		self.Castbar:SetPoint('BOTTOMRIGHT', self.Power, 2, -20)
		
		--self.Castbar:SetReverseFill(true)
		
		------------------
		--  Player Aura --
		------------------
		if Inked.db.char.PlayerAuraIcons == true then
			local Auras = CreateFrame("Frame", nil, self)
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
			Auras:SetHeight(30)
			Auras:SetHeight(30 + 4)
			
			Auras.size = 30
			Auras.onlyShowPlayer = false
			Auras.disableMouse = false
			Auras.gap = 5
			Auras.spacing = 8
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16
			
			Auras.PostCreateIcon = Aura_PostCreateIcon

			self.Auras = Auras
			end
			---Main Hand Enchants --
			self.Enchant = CreateFrame('Frame',  nil, self)
			self.Enchant:SetHeight(30)
			self.Enchant:SetWidth(30 + 4)
			self.Enchant:SetPoint('TOPLEFT', self, 'TOPLEFT', -65, -38)
			self.Enchant.showCD = false
			self.Enchant.size = 30
			self.Enchant.spacing = 4
			self.Enchant.initialAnchor = 'TOPLEFT'
			self.Enchant['growth-y'] = 'RIGHT'
			
			self.Enchant.showBlizzard = true
			
			self.PostCreateEnchantIcon = enchantIcon
			self.PostUpdateEnchantIcons = enchantUpdateIcons
			
		------------------
		--  Player Shaman Totems --
		------------------		
	if select(2, UnitClass'player') == "SHAMAN" then
		local w, h = 45, 16
		local tb = {
			AbbreviateNames = true,
			Destroy = true,
			UpdateColors = true,
		}
		for i = 1, 4 do
			local t = CreateFrame('Frame', nil, self)
			t:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', (i - 1) * (50), 5)
			t:SetSize(w, h)
		
			local bg = t:CreateTexture(nil, 'BACKGROUND')
			bg:SetAllPoints()
			bg:SetTexture(1, 1, 1)
			bg.multiplier = 0.2
			t.bg = bg
		
			local bar = CreateFrame('StatusBar', nil, t)
			bar:SetPoint('RIGHT', -1, 0)
			bar:SetSize(30, 15)
			bar.Reverse = true
			t.StatusBar = bar
		
			local icon = t:CreateTexture(nil, 'ARTWORK')
			icon:SetPoint('LEFT', 1, 0)
			icon:SetSize(h - 2, h - 2)
			icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
			t.Icon = icon
		
			local time = bar:CreateFontString(nil, 'OVERLAY')
			time:SetPoint('RIGHT', -1, 0)
			time:SetFontObject'GameFontNormal'
			time:SetJustifyH'RIGHT'
			t.Time = time
		
			local text = bar:CreateFontString(nil, 'OVERLAY')
				text:SetPoint('LEFT', 1, 0)
			text:SetPoint('RIGHT', time, 'LEFT', -2, 0)
			text:SetFontObject'GameFontNormal'
			text:SetJustifyH'LEFT'
			t.Text = text
		
			tb[i] = t
			end
		self.TotemBar = tb
	end



		------------------
		--  Player Floating Combat Text --
		------------------
		if Inked.db.char.InkedFloatingCombatText == true then
		local fcf = CreateFrame("Frame", nil, self)
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",40,200)
 
		for i = 1, 6 do
		-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
 
		fcf.font = "Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"
		fcf.fontHeight = 24
		fcf.fontFlags = "OUTLINE"

		self.FloatingCombatFeedback = fcf
		end

		-------------------------
		--  Player Combat Icon --
		-------------------------
		
		local CombatAlertFrame = CreateFrame("Frame")
		CombatAlertFrame:SetSize(32,32)
		CombatAlertFrame:SetPoint("RIGHT", self, 32,0)
		CombatAlertFrame:Hide()
		CombatAlertFrame.Bg = CombatAlertFrame:CreateTexture(nil, "BACKGROUND")
		CombatAlertFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\combat")
		CombatAlertFrame.Bg:SetPoint("RIGHT", self, 32,0)
		CombatAlertFrame.Bg:SetSize(32, 32)


		CombatAlertFrame:SetScript("OnEvent", function(self, event, ...)
			if (event == "PLAYER_REGEN_DISABLED") then
				CombatAlertFrame:Show()
			elseif (event == "PLAYER_REGEN_ENABLED") then
				CombatAlertFrame:Hide()
			end
		end)
		CombatAlertFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
		CombatAlertFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
		-----------------------
		--  Player Rest Icon --
		-----------------------
		
	local CombatRestFrame = CreateFrame("Frame")
	CombatRestFrame:SetSize(32, 32)
	CombatRestFrame:SetPoint("TOPLEFT",self,"TOPLEFT",-30,30)
	CombatRestFrame:Hide()
	CombatRestFrame.Bg = CombatRestFrame:CreateTexture(nil, "BACKGROUND")
	CombatRestFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\resting")
	CombatRestFrame.Bg:SetPoint("TOPLEFT",self,"TOPLEFT",-30,30)
	CombatRestFrame.Bg:SetSize(32, 32)

	function RestMe()
	
		if IsResting() == true then
			CombatRestFrame:Show()	
		end
		if IsResting() == false then
			CombatRestFrame:Hide()
		end
	end
	local RestMeframe = CreateFrame("Frame")
	RestMeframe:HookScript("OnUpdate", RestMe)
	
		----------------------
		--  Player PVP Icon --
		----------------------
		
		local PVPFrame = CreateFrame("Frame")
		PVPFrame:SetSize(32, 32)
		PVPFrame:SetPoint("LEFT",self,"LEFT", -32,0); 
		PVPFrame:Hide()
		PVPFrame.Bg = PVPFrame:CreateTexture(nil, "BACKGROUND")
		PVPFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87	
		end
		PVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.75);
		PVPFrame.Bg:SetPoint("LEFT",self,"LEFT", -32,-10); 
		PVPFrame.Bg:SetSize(32, 32)		
		function PlayerPVPMe()
			if UnitIsPVP("player") then	
				PVPFrame:Show()
			else
				PVPFrame:Hide()
			end
		
		end
		local PlayerPVPMeframe = CreateFrame("Frame")
		PlayerPVPMeframe:HookScript("OnUpdate", PlayerPVPMe)
		
		
		
				-- swing Bar--
	
			-- Position and size
			if Inked.db.char.SwingTimer == true then 
			self.Swing = CreateFrame('StatusBar', nil, self)
			self.Swing:SetPoint('TOP', self.Power, 'BOTTOM', 0, -25)
			self.Swing:Hide()

			self.Swing:SetHeight(20)
			self.Swing:SetWidth(235)
			

			self.Swing.Text = self.Swing:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmall')
			self.Swing.Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 12, "OUTLINE")
			self.Swing.Text:SetPoint('CENTER', self.Swing)
			--CreateBackdrop(self.Swing)
			
				self.Swing:SetScript("OnEvent", function(self, event, ...)
				if (event == "PLAYER_REGEN_DISABLED") then
				self:Show()
				elseif (event == "PLAYER_REGEN_ENABLED") then
				self:Hide()
				end
				end)
				self.Swing:RegisterEvent("PLAYER_REGEN_ENABLED")
				self.Swing:RegisterEvent("PLAYER_REGEN_DISABLED")
				
			end

--[[
		if(select(2, UnitClass('player')) == 'ROGUE')  then 
				--return
			--else
			local ClassPower = {}
			for index = 1, 10 do
			local Bar = CreateFrame('StatusBar', nil, self)
			Bar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
			CreateClassPowerBackdrop(Bar)
		
        -- Position and size.
			Bar:SetSize(30, 15)
			Bar:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', (index - 1) * (Bar:GetWidth()+10), 5)

			ClassPower[index] = Bar
			end

		-- Register with oUF
		self.ClassPower = ClassPower
		end 
]]--
--- druid Extra Manabar
	if Inked.db.char.DruidManaBar == true then
	local DruidClassicManaframe = CreateFrame("Frame",nil,UIParent)
	DruidClassicManaframe:SetSize(235, 15)
	DruidClassicManaframe:SetPoint("CENTER",self.Power,"CENTER",0,-70)
	DruidClassicManaframe:Hide()
	DruidClassicManaframe.bar = CreateFrame("StatusBar", nil, DruidClassicManaframe)
	DruidClassicManaframe.bar:SetPoint("TOPLEFT", 0, 0)
	DruidClassicManaframe.bar:SetPoint("TOPRIGHT", 0, 0)
	DruidClassicManaframe.bar:SetHeight(19)
	DruidClassicManaframe.bar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	DruidClassicManaframe.bar:GetStatusBarTexture():SetHorizTile(false)
	DruidClassicManaframe.bar:GetStatusBarTexture():SetVertTile(false)
	DruidClassicManaframe.bar:SetStatusBarColor(0.2,0.25,0.75,1)
	
		local DBPowerText = DruidClassicManaframe.bar:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		DBPowerText:SetPoint("RIGHT", DruidClassicManaframe.bar, -10,0) -- but anchor to the base element so it doesn't wiggle
		DBPowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 12, "OUTLINE")		
		local DBPowerText2 = DruidClassicManaframe.bar:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		DBPowerText2:SetPoint("LEFT", DruidClassicManaframe.bar, 10,0) -- but anchor to the base element so it doesn't wiggle
		DBPowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 12, "OUTLINE")
		--DBPowerText2:SetText(UnitPower("player", 0))
			local function UltraFunction2()
			
				if(select(2, UnitClass('player')) == 'DRUID') then 
					local form = GetShapeshiftFormID()
						if (form == BEAR_FORM or form == CAT_FORM) then
						CreatePowerBackdrop(DruidClassicManaframe)
						DruidClassicManaframe.bar:Show()
						DBPowerText2:SetText(UnitPower("player", 0))
							local MaxMana = UnitPowerMax("player", 0)
							local Mana = UnitPower("player", 0)
							--local druidPercent = math.floor(Mana / MaxMana * 100 + .5)
							DBPowerText:SetText(MaxMana)
							DruidClassicManaframe.bar:SetMinMaxValues(min(0, Mana), MaxMana)
							DruidClassicManaframe.bar:SetValue(Mana)
					else
						DruidClassicManaframe:Hide()

					end
					if (select(2, UnitClass('player')) ~= 'DRUID') then DruidClassicManaframe:Hide() end
				end
			end
		
	local UltraEvent2 = CreateFrame("FRAME")
	UltraEvent2:HookScript("OnUpdate", UltraFunction2)

		local function UltraFunction()
		if(select(2, UnitClass('player')) ~= 'DRUID') then return end
				if(select(2, UnitClass('player')) == 'DRUID') then 
					local form = GetShapeshiftFormID()
						if (form == BEAR_FORM or form == CAT_FORM) then
							--CreateBackdrop(DruidClassicManaframe)
							DruidClassicManaframe:Show()
							else
							DruidClassicManaframe:Hide()
						end
					
				end
			end
	
	local UltraEvent = CreateFrame("FRAME")
	UltraEvent:HookScript("OnUpdate", UltraFunction)
	end
			--- Classic Combo Points ---	
			
			local function CreateComboBackdrop(frame)
			frame:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Textures\\Action Bars\\DruidBTN",
			insets = {top = -2, left = -2, bottom = -2, right = -2}})
			frame:SetBackdropColor(1,0.49,0.04, 1)
			frame:SetBackdropBorderColor(1,0.96,0.41,1)
			end
			local ClassicComboframe = CreateFrame("Frame", nil, UIParent)
			ClassicComboframe:SetSize(175, 20)
			ClassicComboframe:SetPoint("CENTER",self.Health,"CENTER",0,37)

			local ClassicComboPointframe = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe:SetSize(30, 15)
			ClassicComboPointframe:SetPoint("LEFT",ClassicComboframe,"LEFT",0,0)
			local Frametex = ClassicComboPointframe:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe)
			ClassicComboPointframe:Hide()
	
	
			local ClassicComboPointframe2 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe2:SetSize(30, 15)
			ClassicComboPointframe2:SetPoint("LEFT",ClassicComboPointframe,"LEFT",35,0)
			local Frametex = ClassicComboPointframe2:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe2)
	
			local ClassicComboPointframe3 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe3:SetSize(30, 15)
			ClassicComboPointframe3:SetPoint("LEFT",ClassicComboPointframe,"LEFT",70,0)
			local Frametex = ClassicComboPointframe3:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe3)
			
			local ClassicComboPointframe4 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe4:SetSize(30, 15)
			ClassicComboPointframe4:SetPoint("LEFT",ClassicComboPointframe,"LEFT",105,0)
			local Frametex = ClassicComboPointframe4:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe4)
			
			local ClassicComboPointframe5 = CreateFrame("Frame", nil, UIParent)
			ClassicComboPointframe5:SetSize(30, 15)
			ClassicComboPointframe5:SetPoint("LEFT",ClassicComboPointframe,"LEFT",140,0)
			local Frametex = ClassicComboPointframe5:CreateTexture(nil, "BACKGROUND")
			Frametex:SetAllPoints()
			Frametex:SetColorTexture(1,0.96,0.41,1)
			CreateComboBackdrop(ClassicComboPointframe5)

	
	--local combo = GetComboPoints("player", "target")
	local function MyCombo()
	if UnitClass("player") ~= "Druid" or UnitClass("player") ~= "Rogue"  then
			ClassicComboframe:Hide()
	end
	local form = GetShapeshiftFormID()
		if (form == CAT_FORM) then
			ClassicComboframe:Show()
		else
			ClassicComboframe:Hide()
		end
	local combo = GetComboPoints("player", "target")
	--print(combo)
		if combo > 0 then
			--print(combo)
			ClassicComboPointframe:Show()
			else
			ClassicComboPointframe:Hide()
		
		end
		if combo > 1 then
			--print(combo)
			ClassicComboPointframe2:Show()
			else
			ClassicComboPointframe2:Hide()
		end
		if combo > 2 then
			--print(combo)
			ClassicComboPointframe3:Show()
			else
			ClassicComboPointframe3:Hide()
		end
		if combo > 3 then
			--print(combo)
			ClassicComboPointframe4:Show()
			else
			ClassicComboPointframe4:Hide()
		end
		if combo > 4 then
			--print(combo)
			ClassicComboPointframe5:Show()
			else
			ClassicComboPointframe5:Hide()
		end
	end
		
	local MyComboFrame = CreateFrame("Frame", nil, UIParent)
	MyComboFrame:RegisterEvent("PLAYER_TARGET_CHANGED",MyDruidCombo)
	MyComboFrame:HookScript("OnUpdate", MyCombo)
	
	
	end,-- End Player
	boss = function(self)
	self:SetSize(225,65)
		
		
		self.Portrait:SetPoint('TOPRIGHT', self.Health, 'TOPLEFT', 0,0)
		self.Portrait:SetSize(65, 65)
		
		self.Health:SetHeight(65-20)
		self.Power:SetHeight(65-45)
		
		self.Castbar:SetSize(225+65, 25)
		self.Castbar:SetPoint('BOTTOM', self.Power, -32, -27)


	
	end, --end boss
	pet = function(self)
		-- pet specific stuff
		---------------------------
		--  Player Pet Set Up  --
		---------------------------
		
		self:SetSize(180,40)
		CreateBackdrop(self)
		
		------------------------
		--  Player Pet Level  --
		------------------------
		
		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("LEFT", self, -35,15) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 13, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		
		---------------------------
		--  Player Pet Name  --
		---------------------------
		
		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,2) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 15, "OUTLINE")
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		-------------------------------
		--  Player Pet Power Values  --
		-------------------------------		
		
		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!

		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		
		--------------------------------
		--  Player Pet Health Values  --
		--------------------------------
		
		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self,-5,2) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 5,2) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!

		---------------------------
		--  Player Pet Portrait  --
		---------------------------		
		
		self.Portrait:SetPoint('CENTER', self.Health, 'CENTER', 0,0)
		self.Portrait:SetSize(180, 25)
		self.Portrait:SetAlpha(0.45)
		-----------------------------------------------
		--  Player Pet Health and Power Adjustments  --
		-----------------------------------------------		
		
		self.Health:SetHeight(26)
		self.Power:SetHeight(20)
		self.Health:SetPoint('TOP', self,'TOP', 0, 2)
		self.Power:SetPoint('BOTTOM', self.Health,'BOTTOM', 0, -20)
		
		if UnitClass("player") == "Hunter" then
			
		end
		 
		------------------------------------------------------
		--  Player Pet Cast Bar (Not Availible in Classic)  --
		------------------------------------------------------	
		
		self.Castbar:SetPoint('CENTER', UIParent, 0, 0)
		self.Castbar:SetSize(145, 15)
		
		------------------------
		--  Player Pet Auras  --
		------------------------	
		if Inked.db.char.PlayerAuraIcons == true then
		local Auras = CreateFrame("Frame", nil, self)
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,4)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 4)
			Auras:SetHeight(20)
			Auras:SetHeight(20 + 4)

			Auras.size = 20
			Auras.onlyShowPlayer = false
			Auras.gap = 5
			Auras.spacing = 4
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
			end
			
			 -- Position and size
    local PetHappiness = CreateFrame('Frame', nil, self)
			PetHappiness:SetSize(32, 32)
			PetHappiness:SetPoint('LEFT', self, 'LEFT',-38,-10)

			-- Register it with oUF
			self.PetHappiness = PetHappiness
		
	end,-- End Pet
	target = function(self)
		
		--------------------
		--  Target Set Up --
		--------------------
		
		self:SetSize(235,65)
		CreateBackdrop(self)

		
		-------------------------------------
		--  Adjust Target Health and Power --
		-------------------------------------
		
		self.Health:SetHeight(45)
		self.Power:SetHeight(22)
		self.Health:SetReverseFill(true)
		self.Power:SetReverseFill(true)
		self.Power:SetPoint('BOTTOM', self.Health,'BOTTOM', 0, -22)
		--[[
		local function UnitPowerTypeFunc()
		local t = {[0] = "mana", [1] = "rage", [2] = "focus", [3] = "energy", [4] = "happiness", [5] = "runes", [6] = "runic power", [7] = "soul shards", [8] = "eclipse", [9] = "holy power"}
			--print(UnitName("player") .. "'s " .. t[UnitPowerType("player")] .. ": " .. UnitPower("player"))
		--if t[UnitPowerType("target")] ~= nil then
			print(t[UnitPowerType("target")])
		--end
		end
		local UnitPowerTypeFrame = CreateFrame("Frame")
		UnitPowerTypeFrame:HookScript("OnUpdate", UnitPowerTypeFunc)
		]]--
		-------------------------
		--  Target Level Value --
		-------------------------
		
		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", self, -35,-3) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		
		-------------------------
		--  Target Name Value --
		-------------------------	
		
		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 30,-3) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
		NameText:SetWidth(400)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		-------------------------
		--  Target Power Value --
		-------------------------	
		
		
		
		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!
		

	
		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		
				
		--------------------------
		--  Target Health Value --
		--------------------------
		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!
		

		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!
		
		
		----------------------
		--  Target Portrait --
		----------------------
		
		self.Portrait:SetPoint('CENTER', self, 'CENTER', 0, 0)
		self.Portrait:SetSize(235, 65)
		self.Portrait:SetAlpha(0.45)
		-----------------------
		--  Target Cast bar --
		-----------------------	
		
		self.Castbar:SetSize(233, 15)
		self.Castbar:SetPoint('BOTTOMLEFT', self.Power, 0, -18)
		self.Castbar:SetReverseFill(true)
		-----------------------------
		-- Target Auras
		-----------------------------
		if Inked.db.char.PlayerAuraIcons == true then
		local Auras = CreateFrame("Frame", nil, self)
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
		Auras:SetHeight(30)
		Auras:SetHeight(30 + 4)

		Auras.size = 30
		Auras.onlyShowPlayer = false
		Auras.gap = 5
		Auras.spacing = 4
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 16

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
		end
		-----------------
		--  Target Floating Combat Text--
		-----------------		
		if Inked.db.char.InkedFloatingCombatText == true then
		local fcf = CreateFrame("Frame", nil, self)
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",-40,200)
 
		for i = 1, 6 do
			-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
 
		fcf.font = "Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"
		fcf.fontHeight = 24
		fcf.fontFlags = "OUTLINE"

		self.FloatingCombatFeedback = fcf
		end
		-----------------
		--  Target PVP --
		-----------------	
		
		local TargetPVPFrame = CreateFrame("Frame")
		TargetPVPFrame:SetSize(32, 32)
		TargetPVPFrame:SetPoint("RIGHT", self, 32,0); 
		TargetPVPFrame:Hide()
		TargetPVPFrame.Bg = TargetPVPFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87	
		end
		TargetPVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetPVPFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		TargetPVPFrame.Bg:SetPoint("RIGHT", self, 32,0); 
		TargetPVPFrame.Bg:SetSize(32, 32)		
		function PVPMe()
			if UnitIsPVP("target") then	
				TargetPVPFrame:Show()
			else
				TargetPVPFrame:Hide()
			end
		
		end
		local PVPMeframe = CreateFrame("Frame")
		PVPMeframe:HookScript("OnUpdate", PVPMe)
		
		local TargetEliteFrame = CreateFrame("Frame")
		TargetEliteFrame:SetSize(64, 32)
		TargetEliteFrame:SetPoint("RIGHT", self,64,-32); 
		TargetEliteFrame:Hide()
		TargetEliteFrame.Bg = TargetEliteFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87	
		end
		TargetEliteFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		TargetEliteFrame.Bg:SetPoint("RIGHT", self, 64,-32); 
		TargetEliteFrame.Bg:SetSize(64, 32)		
		
			-------------------
			--  Elite Units --
			-------------------
		local TargetEliteFrame = CreateFrame("Frame")
		TargetEliteFrame:SetSize(64, 32)
		TargetEliteFrame:SetPoint("RIGHT", self,64,-32); 
		TargetEliteFrame:Hide()
		TargetEliteFrame.Bg = TargetEliteFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
									
		TargetEliteFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetEliteFrame.Bg:SetPoint("RIGHT", self, 64,-32); 
		TargetEliteFrame.Bg:SetSize(64, 32)		
		
		function EliteMe()
				if UnitClassification("target") == "elite"  then
						TargetEliteFrame:Show()
						TargetEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
				end
				if UnitClassification("target") ~= "elite"  then
						TargetEliteFrame:Hide()
				end

		
		end
		local EliteMeframe = CreateFrame("Frame")
		EliteMeframe:HookScript("OnUpdate", EliteMe)
			-------------------
			--  Rare Units --
			-------------------
		local TargetRareFrame = CreateFrame("Frame")
		TargetRareFrame:SetSize(64, 32)
		TargetRareFrame:SetPoint("RIGHT", self,64,-32); 
		TargetRareFrame:Hide()
		TargetRareFrame.Bg = TargetRareFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
									
		TargetRareFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetRareFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetRareFrame.Bg:SetPoint("RIGHT", self, 64,-32); 
		TargetRareFrame.Bg:SetSize(64, 32)		
		
		function RareMe()
				if UnitClassification("target") == "rare"  then
						TargetRareFrame:Show()
						TargetRareFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\RareEliteDragons")
				end
				if UnitClassification("target") ~= "rare"  then
						TargetRareFrame:Hide()
				end
				
		
		end
		local RareMeframe = CreateFrame("Frame")
		RareMeframe:HookScript("OnUpdate", RareMe)
		
			-----------------------
			--  Rare Elite Units --
			-----------------------
		local TargetRareEliteFrame = CreateFrame("Frame")
		TargetRareEliteFrame:SetSize(64, 32)
		TargetRareEliteFrame:SetPoint("RIGHT", self,64,-32); 
		TargetRareEliteFrame:Hide()
		TargetRareEliteFrame.Bg = TargetRareEliteFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
									
		TargetRareEliteFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetRareEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetRareEliteFrame.Bg:SetPoint("RIGHT", self, 64,-32); 
		TargetRareEliteFrame.Bg:SetSize(64, 32)		
		
		function RareEliteMe()
				if UnitClassification("target") == "rareelite"  then
						TargetRareEliteFrame:Show()
						TargetRareEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\RareEliteDragons")
				end
				if UnitClassification("target") ~= "rareelite"  then
						TargetRareEliteFrame:Hide()
				end
				
		
		end
		local RareEliteMeframe = CreateFrame("Frame")
		RareEliteMeframe:HookScript("OnUpdate", RareEliteMe)
		
			-----------------------
			--  World Boss Units --
			-----------------------
		local TargetWorldBossFrame = CreateFrame("Frame")
		TargetWorldBossFrame:SetSize(64, 32)
		TargetWorldBossFrame:SetPoint("RIGHT", self,64,-32); 
		TargetWorldBossFrame:Hide()
		TargetWorldBossFrame.Bg = TargetWorldBossFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
									
		TargetWorldBossFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetWorldBossFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetWorldBossFrame.Bg:SetPoint("RIGHT", self, 64,-32); 
		TargetWorldBossFrame.Bg:SetSize(64, 32)		
		
		function WorlBossMe()
				if UnitClassification("target") == "worldboss"  then
						TargetWorldBossFrame:Show()
						TargetWorldBossFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\RareEliteDragons")
				end
				if UnitClassification("target") ~= "worldboss"  then
						TargetWorldBossFrame:Hide()
				end
				
		
		end
		local WorlBossMeframe = CreateFrame("Frame")
		WorlBossMeframe:HookScript("OnUpdate", WorlBossMe)
		
	end, -- End Target
	targettarget = function(self)
		self:SetSize(180,40)
		CreateBackdrop(self)
			
		----------------------------------
		-- Target of Target Level Text --
		----------------------------------	
		
		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("LEFT", self, -25,0) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 11, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		
		---------------------------------
		-- Target of Target Name Text --
		---------------------------------	
		
		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,2) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 10, "OUTLINE")
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		
		----------------------------------
		-- Target of Target Power Value --
		----------------------------------
		
		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!
		
		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		
		-----------------------------------
		-- Target of Target Health Value --
		-----------------------------------
		
		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -5,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!
		
		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 5,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!
		
		-------------------------------
		-- Target of Target Portrait --
		-------------------------------
		
		self.Portrait:SetPoint('CENTER', self, 'CENTER', 0,0)
		self.Portrait:SetSize(170, 40)
		self.Portrait:SetAlpha(0.45)
		-------------------------------------------------------
		-- Target of Target Health and Power Bar Adjustments --
		-------------------------------------------------------	
		
		self.Health:SetHeight(30)
		self.Power:SetHeight(15)
		self.Health:SetPoint('TOP', self,'TOP', 0, 2)
		self.Power:SetPoint('BOTTOM', self.Health,'BOTTOM', 0, -15)
		-------------------------------
		-- Target of Target Cast Bar --
		-------------------------------
		
		self.Castbar:Hide()
		
	end, -- End Target of Target	
}
	UnitSpecific.arena = UnitSpecific.boss 

local Shared = function(self, unit)
	-- Shared layout code.
	
	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------
	
	local Health = CreateFrame("StatusBar", nil, self)
	Health:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	CreateHealthBackdrop(Health)
	
	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg
	

    -----------------
	--  Power Bars --
	-----------------
	
	local Power = CreateFrame("StatusBar", nil, Health)
	Power:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-20)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetAlpha(0.75)
	CreatePowerBackdrop(Power)
	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC 
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg


	------------------
	--  Portrait --
	------------------

	-- 2D Portrait
	-- local Portrait = self:CreateTexture(nil, 'OVERLAY')
    -- Register it with oUF
    --self.Portrait = Portrait
	
	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self)
	
	CreateBackdrop(Portrait)
	Portrait:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Assets\\Buttons\\UNIT-BG13",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		Portrait:SetBackdropColor(0.45,0.45,0.45,0.95)
		
	-- Register it with oUF
	

		self.Portrait = Portrait
	--------------
	-- Cast Bar --
	--------------
	
	-- Position and size
	local Castbar = CreateFrame("StatusBar", nil, self)
	Castbar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r 
				local MyGreen = color.g 
				local MyBlue = color.b 
	if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87	
		else
		MyRed = color.r 
		MyGreen = color.g 
		MyBlue = color.b 
	end
	Castbar:SetStatusBarColor(MyRed,MyGreen,MyBlue,1)
	

	-- Add a background
	CreateSpellBackdrop(Castbar)
	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(45, 45)
	Spark:SetBlendMode("ADD")
   
	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 14, "OUTLINE")
	Time:SetTextColor(1, 1, 1)
	Time:SetPoint("RIGHT", Castbar, -3, 1)
	--Time:SetAlpha(0.35)
   
	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 11, "OUTLINE")
	Text:SetTextColor(1, 1, 1)
	Text:SetPoint("LEFT", Castbar, 3, 1)
	Text:SetAlpha(1)
   
	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)
	
	local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
    Icon:SetSize(20, 20)
    Icon:SetPoint('LEFT', Castbar, 'LEFT',-20,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")
   
	-- Register it with oUF
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	self.Castbar.Icon = Icon
	

	
	-----------------
	-- Smooth Bars --
	-----------------
	
	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end

	--------------
	-- Rez Icon --
	--------------
	
	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(16, 16)
	ResurrectIcon:SetPoint('CENTER', self.Health)
   
	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	----------------
	-- Raid icons --
	----------------
	
	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(16, 16)
	RaidTargetIndicator:SetPoint('CENTER', self.Health)
	
	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator
			
	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
		end
end

oUF:RegisterStyle("keivampLayout2", Shared)
oUF:Factory(function(self)
if Inked.db.char.UF2  == false then return end
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("keivampLayout2")
     self:Spawn("player"):SetPoint("CENTER",UIParent,"CENTER",-235,-250)
	 self:Spawn("target"):SetPoint("CENTER",UIParent,"CENTER",235,-250)
	 self:Spawn("pet"):SetPoint("CENTER",UIParent,"CENTER",-375,-375)
	 self:Spawn("targettarget"):SetPoint("CENTER",UIParent,"CENTER",375,-375)
	 self:Spawn("boss"):SetPoint("CENTER",UIParent,"CENTER",0,350)
 
end)

