﻿--[[
##########################################################
Inked!: keivamp
##########################################################
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
  -----------------------------
  -- INIT
  -----------------------------
  --get the addon namespace
  local addon, ns = ...
  local addonName, addon = ...
  --generate a holder for the config data
	local G, F, C, L = unpack(select(2,...))
  local cfg = CreateFrame("Frame")
   

  -----------------------------
  -- ACTIONBUTTON CONFIG
  -----------------------------
local ThisTexture = ("")
		if  UnitClass("player") == "Paladin" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\PaladinBTN")
		end
		if  UnitClass("player") == "Death Knight" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\DeathKnightBTN")
		end
		if  UnitClass("player") == "Demon Hunter" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\DemonHunterBTN")
		end
		if  UnitClass("player") == "Druid" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\DruidBTN")
		end
		if  UnitClass("player") == "Hunter" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\HunterBTN")
		end
		if  UnitClass("player") == "Mage" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\MageBTN")
		end
		if  UnitClass("player") == "Rogue" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\RogueBTN")
		end
		if  UnitClass("player") == "Shaman" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\ShamanBTN")
		end
		if  UnitClass("player") == "Warlock" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\WarlockBTN")
		end
		if  UnitClass("player") == "Monk" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\MonkBTN")
		end
		if  UnitClass("player") == "Warrior" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\WarriorBTN")
		end
		if  UnitClass("player") == "Priest" then
			ThisTexture =("Interface\\Addons\\Inked\\Textures\\Action Bars\\PriestBTN")
		end
  cfg.textures = {
    normal            = ThisTexture,
    flash             = "Interface\\AddOns\\Inked\\Action Bars\\media\\flash",
    highlight         = "Interface\\AddOns\\Inked\\Action Bars\\media\\highlight",
    pushed            = "Interface\\AddOns\\Inked\\Action Bars\\media\\highlight",
    checked           = "Interface\\AddOns\\Inked\\Action Bars\\media\\checked",
    equipped          = "Interface\\AddOns\\Inked\\Action Bars\\media\\normal",
    buttonback        = "Interface\\AddOns\\Inked\\Action Bars\\media\\button_background",
    outer_shadow      = "Interface\\AddOns\\Inked\\Action Bars\\media\\outer_shadow",
  }

  cfg.background = {
    showbg            = true,  --show an background image?
    showshadow        = true,  --show an outer shadow?
    backgroundcolor   = { r = 0, g = 0, b = 0, a = 0.15},
    shadowcolor       = { r = 0, g = 0, b = 0, a = 1},
    inset             = -2,  
	padding           = -1,  
  }

  cfg.color = {
     normal            = { r = 1, g = 1, b = 1, },
    equipped          = { r = 0.1, g = 0.5, b = 0.1, },
  }

  cfg.hotkeys = {
    show            = true,
    fontsize        = 14,
    pos1             = { a1 = "TOPRIGHT", x = 0, y = -2 },
    pos2             = { a1 = "TOPLEFT", x = 0, y = -2 }, --important! two points are needed to make the hotkeyname be inside of the button--原数值都是0
  }

  cfg.macroname = {
    show            = true,
    fontsize        = 14,
    pos1             = { a1 = "BOTTOMLEFT", x = 0, y = 4 },
    pos2             = { a1 = "BOTTOMRIGHT", x = 0, y = 4 }, --important! two points are needed to make the macroname be inside of the button--原数值都是0
  }

  cfg.itemcount = {
    show            = true,
    fontsize        = 14,
    pos1             = { a1 = "BOTTOMRIGHT", x = 0, y = 2 },
  }

  cfg.cooldown = {
    spacing         = 0,
  }

  cfg.icon = {
    padding = 1,
  }
  
  cfg.font = STANDARD_TEXT_FONT
  ---------------------------------------
  -- VARIABLES
  ---------------------------------------
   
  --backdrop settings
  local bgfile, edgefile = "", ""
  if cfg.background.showshadow then edgefile = cfg.textures.outer_shadow end

  --backdrop
  local backdrop = {
    bgFile = bgfile,
    edgeFile = edgefile,
    tile = false,
    tileSize = 32,
    edgeSize = cfg.background.inset,
    insets = {
      left = cfg.background.inset,
      right = cfg.background.inset,
      top = cfg.background.inset,
      bottom = cfg.background.inset,
    },
  }

  ---------------------------------------
  -- FUNCTIONS
  ---------------------------------------
  local function applyBackground(bu)
    if not bu or (bu and bu.bg) then return end
    --shadows+background
    if bu:GetFrameLevel() < 1 then bu:SetFrameLevel(1) end
    if cfg.background.showbg or cfg.background.showshadow then
      bu.bg = CreateFrame("Frame", nil, bu)
      bu.bg:SetAllPoints(bu)
      bu.bg:SetPoint("TOPLEFT", bu, "TOPLEFT", -cfg.background.padding, cfg.background.padding)  --阴影边界与按钮边界的距离--阴影边框，此数值需要与inset相同，inset向里的边界 才能与 背景边框 重合，数值就为边框宽度
      bu.bg:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", cfg.background.padding, -cfg.background.padding)
      bu.bg:SetFrameLevel(bu:GetFrameLevel()-1)
      if cfg.background.showbg then
        local t = bu.bg:CreateTexture(nil,"BACKGROUND",-8)
        t:SetTexture(cfg.textures.buttonback)
        t:SetAllPoints(bu)
        t:SetVertexColor(cfg.background.backgroundcolor.r,cfg.background.backgroundcolor.g,cfg.background.backgroundcolor.b,cfg.background.backgroundcolor.a)
      end
      bu.bg:SetBackdrop(backdrop)
      if cfg.background.showshadow then
        bu.bg:SetBackdropBorderColor(cfg.background.shadowcolor.r,cfg.background.shadowcolor.g,cfg.background.shadowcolor.b,cfg.background.shadowcolor.a)
      end
    end
  end

  --style extraactionbutton
  local function styleExtraActionButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ho = _G[name.."HotKey"]
    --remove the style background theme
    bu.style:SetTexture(nil)
    hooksecurefunc(bu.style, "SetTexture", function(self, texture)
      if texture then
        --print("reseting texture: "..texture)
        self:SetTexture(nil)
      end
    end)
    --icon
    bu.icon:SetTexCoord(0.1,0.9,0.1,0.9)
    bu.icon:SetAllPoints(bu)
    --cooldown
    bu.cooldown:SetAllPoints(bu.icon)
    --hotkey
    ho:Hide()
    --add button normaltexture
	bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
	bu:SetSize(52,52)
    local nt = bu:GetNormalTexture()
    nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
    nt:SetAllPoints(bu)
	hooksecurefunc(nt, "SetVertexColor", function(nt, r, g, b, a)
      local bu = nt:GetParent()
      local action = bu.action
      --print("bu"..bu:GetName().."R"..r.."G"..g.."B"..b)
      if r==1 and g==1 and b==1 and ExtraActionButton1 then
        if cfg.color.equipped.r == 1 and  cfg.color.equipped.g == 1 and  cfg.color.equipped.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      elseif r==0.5 and g==0.5 and b==1 then
        --blizzard oom color
        if cfg.color.normal.r == 0.5 and  cfg.color.normal.g == 0.5 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.499,0.499,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      elseif r==1 and g==1 and b==1 then
        if cfg.color.normal.r == 1 and  cfg.color.normal.g == 1 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      end
    end)
    --apply background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  --initial style func
  local function styleActionButton(bu)
    if not bu or (bu and bu.rabs_styled) then
      return
    end
    local action = bu.action
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local co  = _G[name.."Count"]
    local bo  = _G[name.."Border"]
    local ho  = _G[name.."HotKey"]
    local cd  = _G[name.."Cooldown"]
    local na  = _G[name.."Name"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture"]
    local fbg  = _G[name.."FloatingBG"]
    local fob = _G[name.."FlyoutBorder"]
    local fobs = _G[name.."FlyoutBorderShadow"]
    if fbg then fbg:Hide() end  --floating background
    --flyout border stuff
    if fob then fob:SetTexture(nil) end
    if fobs then fobs:SetTexture(nil) end
    bo:SetTexture(nil) --hide the border (plain ugly, sry blizz)
    --hotkey
    ho:SetFont(cfg.font, cfg.hotkeys.fontsize, "OUTLINE")
    ho:ClearAllPoints()
    ho:SetPoint(cfg.hotkeys.pos1.a1,bu,cfg.hotkeys.pos1.x,cfg.hotkeys.pos1.y)
    ho:SetPoint(cfg.hotkeys.pos2.a1,bu,cfg.hotkeys.pos2.x,cfg.hotkeys.pos2.y)


    --applying the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    if not nt then
      --fix the non existent texture problem (no clue what is causing this)
      nt = bu:GetNormalTexture()
    end
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)  --图标与背景边框之间的空隙
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --adjust the cooldown frame
    cd:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.cooldown.spacing, -cfg.cooldown.spacing)
    cd:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.cooldown.spacing, cfg.cooldown.spacing)
    --apply the normaltexture
    if action and IsEquippedAction(action) then
      bu:SetNormalTexture(cfg.textures.equipped)
      nt:SetVertexColor(cfg.color.equipped.r,cfg.color.equipped.g,cfg.color.equipped.b,1)
    else
      bu:SetNormalTexture(cfg.textures.normal)
      nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
    end
    --make the normaltexture match the buttonsize
	if bu ~= nil then
    nt:SetAllPoints(bu)
	end
    --hook to prevent Blizzard from reseting our colors
    hooksecurefunc(nt, "SetVertexColor", function(nt, r, g, b, a)
      local bu = nt:GetParent()
      local action = bu.action
      --print("bu"..bu:GetName().."R"..r.."G"..g.."B"..b)
      if r==1 and g==1 and b==1 and action and (IsEquippedAction(action)) then
        if cfg.color.equipped.r == 1 and  cfg.color.equipped.g == 1 and  cfg.color.equipped.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(cfg.color.equipped.r,cfg.color.equipped.g,cfg.color.equipped.b,1)
        end
      elseif r==0.5 and g==0.5 and b==1 then
        --blizzard oom color
        if cfg.color.normal.r == 0.5 and  cfg.color.normal.g == 0.5 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.499,0.499,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      elseif r==1 and g==1 and b==1 then
        if cfg.color.normal.r == 1 and  cfg.color.normal.g == 1 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      end
    end)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  local function styleLeaveButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end  
    
  --style pet buttons
  local function stylePetButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture2"]
	local ho  = _G[name.."HotKey"]
	ho:Hide()
    nt:SetAllPoints(bu)
    --applying color
    nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
    --setting the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    hooksecurefunc(bu, "SetNormalTexture", function(self, texture)
      --make sure the normaltexture stays the way we want it
      if texture and texture ~= cfg.textures.normal then
        self:SetNormalTexture(cfg.textures.normal)
      end
    end)
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  --style stance buttons
  local function styleStanceButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture2"]
    nt:SetAllPoints(bu)
    --applying color
    nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
    --setting the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  --style possess buttons
  local function stylePossessButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture"]
    nt:SetAllPoints(bu)
    --applying color
    nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
    --setting the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end
  
  --style leave button++++
  local function styleLeaveButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
	local name = bu:GetName()
  	local nt = bu:GetNormalTexture()
	local bo = bu:CreateTexture(name.."Border", "BACKGROUND", nil, -7)
  	--nt:SetTexCoord(0.2,0.8,0.2,0.8)--修改了图标
  	nt:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
    nt:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)
  	bo:SetTexture(cfg.textures.normal)
  	bo:SetTexCoord(0, 1, 0, 1)
  	bo:SetDrawLayer("BACKGROUND",- 7)
  	bo:SetVertexColor(0, 0, 0)
	bo:ClearAllPoints()
	bo:SetAllPoints(bu)

	bu:SetHighlightTexture("Interface\\AddOns\\AddUI\\UI\\media\\bag-highlight")
    bu:SetPushedTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down.blp")

    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end
  
  
  
  --style bags++++
  local function styleBag(bu)
  	if not bu or (bu and bu.rabs_styled) then return end
	local name = bu:GetName()
	local ic  = _G[name.."IconTexture"]
	local nt  = _G[name.."NormalTexture"]
	nt:SetTexCoord(0,1,0,1)
	nt:SetDrawLayer("BACKGROUND", -7)
	nt:SetVertexColor(0.3, 0.3, 0.3)----(0.29, 0.3, 0.29)
	nt:SetAllPoints(bu)
	local bo = bu.IconBorder
	bo:Hide()
	bo.Show = function() end
	ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 2, -2)
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -2, 2)
  	bu:SetNormalTexture(cfg.textures.normal)
	bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
  -- bu.SlotHighlightTexture:SetTexture(cfg.textures.highlight)
 	
      --make sure the normaltexture stays the way we want it
  	  hooksecurefunc(bu, "SetNormalTexture", function(self, texture)
      if texture and texture ~= cfg.textures.normal then
        	self:SetNormalTexture(cfg.textures.normal)
      end
   	  end)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
	--hook to prevent Blizzard from reseting our colors
    hooksecurefunc(nt, "SetVertexColor", function(nt, r, g, b, a)
      local bu = nt:GetParent()
      local action = bu.action
      --print("bu"..bu:GetName().."R"..r.."G"..g.."B"..b)
      if r==1 and g==1 and b==1 and action and (IsEquippedAction(action)) then
        if cfg.color.equipped.r == 1 and  cfg.color.equipped.g == 1 and  cfg.color.equipped.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(cfg.color.equipped.r,cfg.color.equipped.g,cfg.color.equipped.b,1)
        end
      elseif r==0.5 and g==0.5 and b==1 then
        --blizzard oom color
        if cfg.color.normal.r == 0.5 and  cfg.color.normal.g == 0.5 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.499,0.499,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      elseif r==1 and g==1 and b==1 then
        if cfg.color.normal.r == 1 and  cfg.color.normal.g == 1 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(0.3, 0.3, 0.3)----(0.29, 0.3, 0.29)
        end
      end
    end)
  end

  --update hotkey func
  local function updateHotkey(self, actionButtonType)
    local ho = _G[self:GetName().."HotKey"]
    if ho and not cfg.hotkeys.show and ho:IsShown() then
      ho:Hide()
    end
  end

  ---------------------------------------
  -- INIT
  ---------------------------------------

  local function init()
    --style the actionbar buttons
 --if Inked.db.char.UseActionBars == false then return end
	--if InkedChar.mmb ==  false  then return end
	

    for i = 1, NUM_ACTIONBAR_BUTTONS do
     styleActionButton(_G["ActionButton"..i])
     styleActionButton(_G["MultiBarBottomLeftButton"..i])
      styleActionButton(_G["MultiBarBottomRightButton"..i])
      styleActionButton(_G["MultiBarRightButton"..i])
      styleActionButton(_G["MultiBarLeftButton"..i])
    end
    for i = 1, 6 do
      styleActionButton(_G["OverrideActionBarButton"..i])
    end
	--style bags++++
    for i = 0, 3 do
	  styleBag(_G["CharacterBag"..i.."Slot"])
    end
	styleBag(MainMenuBarBackpackButton)
    --style leave button
    styleLeaveButton(OverrideActionBarLeaveFrameLeaveButton)
    styleLeaveButton(rABS_LeaveVehicleButton)
	styleLeaveButton(MainMenuBarVehicleLeaveButton)--++++
    --petbar buttons
    for i=1, NUM_PET_ACTION_SLOTS do
      stylePetButton(_G["PetActionButton"..i])
    end
    --stancebar buttons
    for i=1, NUM_STANCE_SLOTS do
      styleStanceButton(_G["StanceButton"..i])
    end
    --possess buttons
    --for i=1, NUM_POSSESS_SLOTS do
     -- stylePossessButton(_G["PossessButton"..i])
   -- end
    --extraactionbutton1
    styleExtraActionButton(ExtraActionButton1)
    --spell flyout
    --SpellFlyoutBackgroundEnd:SetTexture(nil)
    --SpellFlyoutHorizontalBackground:SetTexture(nil)
    --SpellFlyoutVerticalBackground:SetTexture(nil)
   -- local function checkForFlyoutButtons(self)
   --   local NUM_FLYOUT_BUTTONS = 10
   --   for i = 1, NUM_FLYOUT_BUTTONS do
   --     styleActionButton(_G["SpellFlyoutButton"..i])
   --  end
   -- end
   -- SpellFlyout:HookScript("OnShow",checkForFlyoutButtons)
	

      hooksecurefunc("ActionButton_UpdateHotkeys",  updateHotkey)


  end

  ---------------------------------------
  -- CALL
  ---------------------------------------

  local a = CreateFrame("Frame")
 
  a:RegisterEvent("PLAYER_LOGIN")
  a:SetScript("OnEvent", init)